-- Application.applescript
global decodePaths
global encodePaths
global fingerprintPaths
global MD5Paths
global SHNtoolPaths
global APEPaths
global theFingerprints
global fixPaths
global wavpackPaths
global lossyPaths

global shellPath
global binariesPath
global tagPaths
global utilPaths
global md5CheckFlag
global fingerprintcheckflag

global errorFlag

global errorLog
global debugString

global trackNames

global pantherFlag
global leopardFlag

on idle
	(* Add any idle time processing here. *)
end idle


on will open theObject
	if theObject's name is "mainWindow" then
		
		set iPaths to ""
		set fileType to ""
		set decodePaths to {} as list
		set encodePaths to {} as list
		set fingerprintPaths to {} as list
		set MD5Paths to {} as list
		set SHNtoolPaths to {} as list
		set APEPaths to {} as list
		set fixPaths to {} as list
		set theFingerprints to {} as list
		set tagPaths to {} as list
		set utilPaths to {} as list
		set wavpackPaths to {} as list
		set lossyPaths to {} as list
		
		set binariesPath to getQuotedForm(unix_path(path to me as Unicode text) & "Contents/Resources/Binaries/bin")
		
		--set cdparanoiaPath to getQuotedForm(unix_path(path to me as Unicode text) & "Contents/Resources/Binaries/bin/cd-paranoia")
		--set binariesPath to "/usr/local/bin" as Unicode text
		
		--set shellPath to "export PATH=:/usr/local/bin:$PATH; "
		set shellPath to "export PATH=:" & binariesPath & ":$PATH; "
		set md5CheckFlag to false as boolean
		set flacCheckFlag to false as boolean
		set fingerprintcheckflag to false as boolean
		set errorFlag to false as boolean
		
		set errorLog to ""
		set debugString to ""
		
		set trackNames to {} as list
		
		
		--check to see what system we're on.  we'll need this for monkey's audio, which uses a different version for pre 10.3 systems
		try
			set the hexData to system attribute "sysv"
			set hexString to {}
			repeat 4 times
				set hexString to ((hexData mod 16) as string) & hexString
				set hexData to hexData div 16
			end repeat
			set the OS_version to the hexString as string
			
			if the OS_version is less than "1030" then
				set pantherFlag to false as boolean
				set leopardFlag to false as boolean
			else if the OS_version is greater than or equal to "1050" then
				set leopardFlag to true as boolean
				set pantherFlag to true as boolean
			else
				set pantherFlag to true as boolean
				set leopardFlag to false as boolean
			end if
		on error
			set pantherFlag to false as boolean
		end try
		
	end if
	
end will open


on open names
	set theChecksumTab to tab view item "checksumTab" of tab view "tabs" of window "mainWindow"
	set theSHNtoolTab to tab view item "shntoolTab" of tab view "tabs" of window "mainWindow"
	set theFixtab to tab view item "fixtab" of tab view "tabs" of window "mainWindow"
	set theEncodetab to tab view item "encodetab" of tab view "tabs" of window "mainWindow"
	set theDecodetab to tab view item "decodetab" of tab view "tabs" of window "mainWindow"
	set theTagTab to tab view item "tagTab" of tab view "tabs" of window "mainWindow"
	set theUtilTab to tab view item "utilTab" of tab view "tabs" of window "mainWindow"
	set theLossyTab to tab view item "lossyTab" of tab view "tabs" of window "mainWindow"
	
	
	if (the current tab view item of tab view "tabs" of window "mainWindow" is equal to theChecksumTab) then
		
		set iPaths to names
		set fileExtension to ""
		repeat with i in iPaths
			set iPath to (i as Unicode text)
			--set iPath to (i as Unicode text)
			--			set iPath to (POSIX path of iPath)
			set iPath to unix_path(iPath)
			set AppleScript's text item delimiters to "."
			set fileExtension to the last text item of iPath
			if fileExtension is equal to "flac" then
				set fingerprintPaths to fingerprintPaths & iPath
			else if fileExtension is equal to "shn" then
				set MD5Paths to MD5Paths & iPath
			else if fileExtension is equal to "md5" or fileExtension is equal to "st5" then
				set MD5Paths to MD5Paths & iPath
				set md5CheckFlag to true
			else if fileExtension is equal to "ffp" or iPath ends with ".ffp.txt" then
				set fingerprintPaths to fingerprintPaths & iPath
				set fingerprintcheckflag to true
			else if fileExtension is equal to "ape" then
				set APEPaths to APEPaths & iPath
			else if fileExtension is equal to "wv" then
				set wavpackPaths to wavpackPaths & iPath
				
			else
				set MD5Paths to MD5Paths & iPath
				
			end if
		end repeat
		
		if fileExtension is equal to "flac" or fileExtension is equal to "ffp" or iPath ends with ".ffp.txt" then
			set fingerprintPaths to ASCII_Sort(fingerprintPaths)
			addNamesToFingerprintList(fingerprintPaths)
		else if fileExtension is equal to "ape" then
			set APEPaths to ASCII_Sort(APEPaths)
			addNamesToFingerprintList(APEPaths)
		else if fileExtension is equal to "wv" then
			set wavpackPaths to ASCII_Sort(wavpackPaths)
			addNamesToFingerprintList(wavpackPaths)
			
		else
			set MD5Paths to ASCII_Sort(MD5Paths)
			addNamesToMD5List(MD5Paths)
		end if
		
	else if (the current tab view item of tab view "tabs" of window "mainWindow" is equal to theSHNtoolTab) then
		
		set iPaths to names
		repeat with i in iPaths
			set iPath to (i as Unicode text)
			--set iPath to (i as Unicode text)
			set iPath to unix_path(iPath)
			set SHNtoolPaths to SHNtoolPaths & iPath
		end repeat
		
		set SHNtoolPaths to ASCII_Sort(SHNtoolPaths)
		addNamesToSHNtoolList(SHNtoolPaths)
		
	else if (the current tab view item of tab view "tabs" of window "mainWindow" is equal to theFixtab) then
		set iPaths to names
		repeat with i in iPaths
			set iPath to (i as Unicode text)
			--set iPath to (i as Unicode text)
			set iPath to unix_path(iPath)
			set fixPaths to fixPaths & iPath
		end repeat
		
		set fixPaths to ASCII_Sort(fixPaths)
		addNamesToFixList(fixPaths)
		
	else if (the current tab view item of tab view "tabs" of window "mainWindow" is equal to theTagTab) then
		--set debugString to debugString & return & "adding these files to the tag list:" & return
		
		set iPaths to names
		repeat with i in iPaths
			--set debugString to debugString & (i as unicode text) & return
			set iPath to (i as Unicode text)
			--set iPath to (i as Unicode text)
			set iPath to unix_path(iPath)
			set tagPaths to tagPaths & iPath
		end repeat
		
		set tagPaths to ASCII_Sort(tagPaths)
		makeFlacTable(tagPaths)
		
	else if (the current tab view item of tab view "tabs" of window "mainWindow" is equal to theUtilTab) then
		
		
		set iPaths to names
		repeat with i in iPaths
			set iPath to (i as Unicode text)
			--set iPath to (i as Unicode text)
			set iPath to unix_path(iPath)
			set utilPaths to utilPaths & iPath
		end repeat
		set utilPaths to ASCII_Sort(utilPaths)
		addNamesToUtilList(utilPaths)
		
	else if (the current tab view item of tab view "tabs" of window "mainWindow" is equal to theEncodetab) then
		
		
		set iPaths to names
		repeat with i in iPaths
			set iPath to (i as Unicode text)
			--set iPath to (i as Unicode text)
			set iPath to unix_path(iPath)
			set encodePaths to encodePaths & iPath
		end repeat
		set encodePaths to ASCII_Sort(encodePaths)
		addNamesToEncodeList(encodePaths)
		
	else if (the current tab view item of tab view "tabs" of window "mainWindow" is equal to theLossyTab) then
		
		
		set iPaths to names
		repeat with i in iPaths
			set iPath to (i as Unicode text)
			--set iPath to (i as Unicode text)
			set iPath to unix_path(iPath)
			set lossyPaths to lossyPaths & iPath
		end repeat
		set lossyPaths to ASCII_Sort(lossyPaths)
		addNamesToLossyList(lossyPaths)
		
		
	else
		set iPaths to names
		repeat with i in iPaths
			set iPath to (i as Unicode text)
			--set iPath to (i as Unicode text)
			set iPath to unix_path(iPath)
			set AppleScript's text item delimiters to "."
			set fileExtension to the last text item of iPath
			
			if fileExtension is equal to "flac" then
				set decodePaths to decodePaths & iPath
				set the current tab view item of tab view "tabs" of window "mainWindow" to theDecodetab
			else if fileExtension is equal to "shn" then
				set decodePaths to decodePaths & iPath
				set the current tab view item of tab view "tabs" of window "mainWindow" to theDecodetab
			else if fileExtension is equal to "ape" then
				set decodePaths to decodePaths & iPath
				set the current tab view item of tab view "tabs" of window "mainWindow" to theDecodetab
			else if fileExtension is equal to "wv" then
				set decodePaths to decodePaths & iPath
				set the current tab view item of tab view "tabs" of window "mainWindow" to theDecodetab
			else if fileExtension is equal to "tta" then
				set decodePaths to decodePaths & iPath
				set the current tab view item of tab view "tabs" of window "mainWindow" to theDecodetab
			else if fileExtension is equal to "m4a" then
				if isALAC(iPath) is true then
					set decodePaths to decodePaths & iPath
					set the current tab view item of tab view "tabs" of window "mainWindow" to theDecodetab
				else
					--do nothing
				end if
				
			else if fileExtension is equal to "wav" then
				set encodePaths to encodePaths & iPath
				set the current tab view item of tab view "tabs" of window "mainWindow" to theEncodetab
			else if fileExtension is equal to "aif" then
				set encodePaths to encodePaths & iPath
				set the current tab view item of tab view "tabs" of window "mainWindow" to theEncodetab
			else if fileExtension is equal to "aiff" then
				set encodePaths to encodePaths & iPath
				set the current tab view item of tab view "tabs" of window "mainWindow" to theEncodetab
			else if fileExtension is equal to "md5" or fileExtension is equal to "st5" then
				set MD5Paths to MD5Paths & iPath
				set md5CheckFlag to true
				set the current tab view item of tab view "tabs" of window "mainWindow" to theChecksumTab
			else if fileExtension is equal to "ffp" or iPath ends with ".ffp.txt" then
				set fingerprintPaths to fingerprintPaths & iPath
				set fingerprintcheckflag to true
				set the current tab view item of tab view "tabs" of window "mainWindow" to theChecksumTab
			else --if no extension or other extension assume we're encoding
				
				--set theResult to do shell script shellPath & "ls -l " & iPath
				--makeMessageWindow(theResult)
				set encodePaths to encodePaths & iPath
				set the current tab view item of tab view "tabs" of window "mainWindow" to theEncodetab
			end if
		end repeat
		
		
		set decodePaths to ASCII_Sort(decodePaths)
		addNamesToDecodeList(decodePaths)
		
		set encodePaths to ASCII_Sort(encodePaths)
		addNamesToEncodeList(encodePaths)
		
		set fingerprintPaths to ASCII_Sort(fingerprintPaths)
		addNamesToFingerprintList(fingerprintPaths)
		
		if md5CheckFlag is equal to true then
			set MD5Paths to ASCII_Sort(MD5Paths)
			addNamesToMD5List(MD5Paths)
		end if
		
	end if
	
	
	return true
	
end open

on addNamesToDecodeList(iPaths)
	set contents of text view "decodeList" of scroll view "decodeList" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow" to ""
	repeat with i in iPaths
		set iPath to (i as Unicode text)
		
		set theContents to the contents of text view "decodeList" of scroll view "decodeList" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow"
		
		set AppleScript's text item delimiters to "/"
		set fileName to the last text item of iPath
		
		set contents of text view "decodeList" of scroll view "decodeList" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow" to theContents & fileName & return
		
	end repeat
	
end addNamesToDecodeList

on addNamesToFingerprintList(iPaths)
	addNamesToMD5List(iPaths)
	
end addNamesToFingerprintList

on addNamesToMD5List(iPaths)
	set contents of text view "checksumList" of scroll view "checksumList" of view of tab view item "checksumTab" of tab view "tabs" of window "mainWindow" to ""
	repeat with i in iPaths
		set iPath to (i as Unicode text)
		set theContents to the contents of text view "checksumList" of scroll view "checksumList" of view of tab view item "checksumTab" of tab view "tabs" of window "mainWindow"
		set AppleScript's text item delimiters to "/"
		set fileName to the last text item of iPath
		set contents of text view "checksumList" of scroll view "checksumList" of view of tab view item "checksumTab" of tab view "tabs" of window "mainWindow" to theContents & fileName & return
	end repeat
	
end addNamesToMD5List

on addNamesToSHNtoolList(iPaths)
	set contents of text view "shntoolList" of scroll view "shntoolList" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to ""
	repeat with i in iPaths
		set iPath to (i as Unicode text)
		
		set theContents to the contents of text view "shntoolList" of scroll view "shntoolList" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow"
		
		set AppleScript's text item delimiters to "/"
		set fileName to the last text item of iPath
		
		set contents of text view "shntoolList" of scroll view "shntoolList" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to theContents & fileName & return
		
	end repeat
	
end addNamesToSHNtoolList

on addNamesToFixList(iPaths)
	set contents of text view "fixList" of scroll view "fixList" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" to ""
	repeat with i in iPaths
		set iPath to (i as Unicode text)
		
		set theContents to the contents of text view "fixList" of scroll view "fixList" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow"
		set AppleScript's text item delimiters to "/"
		set fileName to the last text item of iPath
		
		set contents of text view "fixList" of scroll view "fixList" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" to theContents & fileName & return
		
	end repeat
	
end addNamesToFixList

on addNamesToUtilList(iPaths)
	set contents of text view "utilList" of scroll view "utilList" of view of tab view item "utilTab" of tab view "tabs" of window "mainWindow" to ""
	repeat with i in iPaths
		set iPath to (i as Unicode text)
		
		set theContents to the contents of text view "utilList" of scroll view "utilList" of view of tab view item "utilTab" of tab view "tabs" of window "mainWindow"
		set AppleScript's text item delimiters to "/"
		set fileName to the last text item of iPath
		
		set contents of text view "utilList" of scroll view "utilList" of view of tab view item "utilTab" of tab view "tabs" of window "mainWindow" to theContents & fileName & return
		
	end repeat
	
end addNamesToUtilList

on addNamesToLossyList(iPaths)
	set contents of text view "lossyList" of scroll view "lossyList" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to ""
	repeat with i in iPaths
		set iPath to (i as Unicode text)
		
		set theContents to the contents of text view "lossyList" of scroll view "lossyList" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow"
		set AppleScript's text item delimiters to "/"
		set fileName to the last text item of iPath
		
		set contents of text view "lossyList" of scroll view "lossyList" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to theContents & fileName & return
		
	end repeat
	
end addNamesToLossyList


on addNamesToEncodeList(iPaths)
	set contents of text view "encodeList" of scroll view "encodeList" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to ""
	repeat with i in iPaths
		set iPath to (i as Unicode text)
		set theContents to the contents of text view "encodeList" of scroll view "encodeList" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow"
		set AppleScript's text item delimiters to "/"
		set fileName to the last text item of iPath
		set contents of text view "encodeList" of scroll view "encodeList" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to theContents & fileName & return
	end repeat
	
end addNamesToEncodeList

on makeFlacTable(theFiles)
	
	--set debugString to debugString & return & "adding these to the actual displayed list: " & return
	set theObject to table view "flacFiles" of scroll view "flacFiles" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow"
	--ok from here on
	--- Get the data source from the table view
	set theDataSource to data source of theObject
	
	-- Turn off the updating of the views
	set update views of theDataSource to false
	
	-- Delete all of the data rows in the data source
	delete every data row of theDataSource
	
	-- For every item in the list, make a new data row and set it's contents
	repeat with theItem in theFiles
		--set debugString to debugString & theItem & return
		set AppleScript's text item delimiters to "/"
		set theItem to the last text item of theItem
		--set debugString to debugString & "should be displayed as: " & theItem & return
		set theDataRow to make new data row at end of data rows of theDataSource
		set contents of data cell "flacFiles" of theDataRow to theItem
		
	end repeat
	
	-- Turn back on the updating of the views
	set update views of theDataSource to true
	
	--makeMessageWindow(debugString)
	
end makeFlacTable

on setupDataSource()
	--set up the table for flac tags----------------------------
	-- Create the data source for the table view
	set theDataSource to make new data source at end of data sources with properties {name:"flacFiles"}
	-- Create the "files" data column
	make new data column at end of data columns of theDataSource with properties {name:"flacFiles"}
	-- Assign the data source to the table view
	set theTable to table view "flacFiles" of scroll view "flacFiles" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow"
	set data source of theTable to theDataSource
	set update views of theDataSource to true
	
end setupDataSource

on clicked theObject
	
	if theObject's name is "addEncode" then
		handleAdd()
	end if
	
	if theObject's name is "addDecode" then
		handleAdd()
	end if
	
	if theObject's name is "addChecksum" then
		handleAdd()
	end if
	
	if theObject's name is "addShntool" then
		handleAdd()
	end if
	
	if theObject's name is "addFix" then
		handleAdd()
	end if
	
	if theObject's name is "addFlacTag" then
		handleAdd()
	end if
	
	if theObject's name is "addUtil" then
		handleAdd()
	end if
	
	if theObject's name is "addLossy" then
		handleAdd()
	end if
	
	
	if the theObject's name is "DecodeButton" and decodePaths is not equal to {} then
		handleDecodeClick()
	end if
	
	if theObject's name is "EncodeButton" and encodePaths is not equal to {} then
		handleEncodeClick()
	end if
	
	if theObject's name is "lossyEncodeButton" and lossyPaths is not equal to {} then
		handleLossyEncodeClick()
	end if
	
	if theObject's name is "ChecksumButton" and fingerprintcheckflag is equal to true then
		handleCheckFingerprint()
	end if
	
	if theObject's name is "ChecksumButton" and fingerprintPaths is not equal to {} then
		handleFingerprintClick()
	end if
	
	if theObject's name is "ChecksumButton" and md5CheckFlag is equal to true then
		handleCheckMD5()
	end if
	
	if theObject's name is "ChecksumButton" and MD5Paths is not equal to {} then
		
		set dialogText to "MD5 Checksum Options"
		set dialogMessage to "xACT can create standard md5 checksums or shntool checksums for just the PCM Audio data.  Choose the format that you want.  " & return & return & "note: if you don't know what a shntool md5 is, choose standard"
		set dialogType to critical
		set defaultButtonTitle to "standard"
		set alternateButtonTitle to "shntool"
		
		set theReply to display alert dialogText as dialogType message dialogMessage default button defaultButtonTitle alternate button alternateButtonTitle
		
		if button returned of theReply is equal to "standard" then
			handleMD5Click("md5sum.md5")
		else
			handleShntoolMd5Click("shntoolmd5sum.st5")
		end if
	end if
	
	if theObject's name is "SHNtoolButton" and SHNtoolPaths is not equal to {} then
		handleSHNtoolClick()
	end if
	
	if theObject's name is "ChecksumButton" and APEPaths is not equal to {} then
		set dialogText to "Monkey's Audio Checksum Options"
		set dialogMessage to "Do You want xACT to verify the APE files or create a shntool md5?"
		set dialogType to critical
		set defaultButtonTitle to "verify"
		set alternateButtonTitle to "shntool md5"
		
		set theReply to display alert dialogText as dialogType message dialogMessage default button defaultButtonTitle alternate button alternateButtonTitle
		
		if button returned of theReply is equal to "verify" then
			handleAPEVerify()
		else
			set MD5Paths to APEPaths
			set APEPaths to {}
			handleShntoolMd5Click("md5sum.shntool.md5")
		end if
	end if
	
	if theObject's name is "ChecksumButton" and wavpackPaths is not equal to {} then
		handleWavpackVerify()
	end if
	
	if theObject's name is "FixButton" and fixPaths is not equal to {} then
		handleFixClick()
	end if
	
	
	--	if theObject's name is "flacFiles" then
	--		handleFlacTags()
	--	end if
	
	
	if theObject's name is "writeTagsButton" then
		handleFlacTagsButton()
	end if
	
	if theObject's name is "utilButton" and utilPaths is not equal to {} then
		
		if the current column of matrix "utilOptions" of view of tab view item "utilTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
			handleBatchRename()
		else
			handleParanoiaExtract()
		end if
	end if
	
	
	--following code added 10/8/03 to clear file lists
	if theObject's name is "clearDecode" then
		set contents of text view "decodeList" of scroll view "decodeList" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow" to ""
		
		set decodePaths to {} as list
	end if
	
	if theObject's name is "clearEncode" then
		set contents of text view "encodeList" of scroll view "encodeList" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to ""
		
		set encodePaths to {} as list
	end if
	
	if theObject's name is "clearLossy" then
		set contents of text view "lossyList" of scroll view "lossyList" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to ""
		
		set lossyPaths to {} as list
	end if
	
	
	if theObject's name is "clearChecksum" then
		set contents of text view "checksumList" of scroll view "checksumList" of view of tab view item "checksumTab" of tab view "tabs" of window "mainWindow" to ""
		
		set MD5Paths to {} as list
		set fingerprintPaths to {} as list
	end if
	
	if theObject's name is "clearShntool" then
		set contents of text view "shntoolList" of scroll view "shntoolList" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to ""
		
		set SHNtoolPaths to {} as list
		
	end if
	
	if theObject's name is "clearFix" then
		set contents of text view "fixList" of scroll view "fixList" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" to ""
		
		set fixPaths to {} as list
		
	end if
	if theObject's name is "clearUtil" then
		set contents of text view "utilList" of scroll view "utilList" of view of tab view item "utilTab" of tab view "tabs" of window "mainWindow" to ""
		
		set utilPaths to {} as list
		
	end if
	
	if theObject's name is "clearFlacTag" then
		set theObject to table view "flacFiles" of scroll view "flacFiles" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow"
		--ok from here on
		--- Get the data source from the table view
		set theDataSource to data source of theObject
		
		-- Turn off the updating of the views
		set update views of theDataSource to false
		
		-- Delete all of the data rows in the data source
		delete every data row of theDataSource
		
		set tagPaths to {}
		
		-- Turn back on the updating of the views
		set update views of theDataSource to true
		
		clearFlacTags()
	end if
	
	--end of clear code----------------------
	
	if theObject's name is "mailToButton" then
		open location "mailto:xactdeveloper@gmail.com"
	end if
	
	if theObject's name is "macFlacLink" then
		open location "http://www.danrules.com/macflac/"
	end if
	
	if theObject's name is "flacLink" then
		open location "http://flac.sourceforge.net/"
	end if
	
	if theObject's name is "shortenLink" then
		open location "http://www.etree.org/shnutils/shorten/"
	end if
	
	if theObject's name is "shntoolLink" then
		open location "http://www.etree.org/shnutils/shntool/"
	end if
	
	if theObject's name is "apeLink" then
		open location "http://www.monkeysaudio.com"
	end if
	
	if theObject's name is "lameLink" then
		open location "http://lame.sourceforge.net"
	end if
	
	if theObject's name is "atomicParsleyLink" then
		open location "http://atomicparsley.sourceforge.net/"
	end if
	
	if theObject's name is "flacTagAutoName" then
		if the state of button "flacTagAutoName" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
			showInputWindow()
		end if
	end if
	
	
	if theObject's name is "inputNames" then
		showInputWindow()
	end if
	
	if theObject's name is "inputOK" then
		set trackNames to {} as list
		set theInput to ""
		set theInput to getTrackNameInput()
		
		
		set theDelimiter to return
		set AppleScript's text item delimiters to theDelimiter
		--if for some reason it's not seeing the line breaks normally (found this bug once)
		if (the number of text items in theInput) is equal to 1 then
			set theDelimiter to "
"
			set AppleScript's text item delimiters to theDelimiter
		end if
		
		--display dialog (number of text items of theInput)
		repeat with i from 1 to (number of text items of theInput)
			set theLine to (text item i of theInput)
			if theLine is not equal to "" then
				set trackNames to trackNames & (text item i of theInput)
			end if
		end repeat
		
	end if
	
	if theObject's name is "inputCancel" then
		tell window "inputWindow"
			set visible to false
		end tell
	end if
	
	if theObject's name is "deleteEncode" then
		set deleteEncode to the state of button "deleteEncode" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow"
		
		if deleteEncode is 1 then
			set theReply to display alert "Are you sure you want to delete the original files after encoding?" default button "No" alternate button "Yes"
			
			if button returned of theReply is "No" then
				set the state of button "deleteEncode" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to 0
			end if
		end if
		
	end if
	
	if theObject's name is "deleteDecode" then
		set deleteDecode to the state of button "deleteDecode" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow"
		
		if deleteDecode is 1 then
			set theReply to display alert "Are you sure you want to delete the original files after decoding?" default button "No" alternate button "Yes"
			
			if button returned of theReply is "No" then
				set the state of button "deleteDecode" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow" to 0
			end if
		end if
		
	end if
	
	if theObject's name is "aacVBRStepper" then
		set currentStepperValue to contents of stepper "aacVBRStepper" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow"
		set contents of text field "aacVBRStepperText" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to currentStepperValue
	end if
	
	
	displayRelevantOptions()
	
end clicked

-- This event handler is called when the attached window is loaded from the nib file. 
--
on awake from nib theObject
	-------------------------------------------------------------
	
	if theObject's name is "mainWindow" then
		ShowWindow()
	end if
	
	
	my setPreferences()
	
	
	--set shntool options to invisible
	displayRelevantOptions()
	
	tell text view "decodeList" of scroll view "decodeList" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow" to register drag types {"file names"}
	tell text view "encodeList" of scroll view "encodeList" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to register drag types {"file names"}
	tell text view "checksumList" of scroll view "checksumList" of view of tab view item "checksumTab" of tab view "tabs" of window "mainWindow" to register drag types {"file names"}
	tell text view "shntoolList" of scroll view "shntoolList" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to register drag types {"file names"}
	tell text view "fixList" of scroll view "fixList" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" to register drag types {"file names"}
	tell text view "utilList" of scroll view "utilList" of view of tab view item "utilTab" of tab view "tabs" of window "mainWindow" to register drag types {"file names"}
	tell text view "lossyList" of scroll view "lossyList" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to register drag types {"file names"}
	
	tell table view "flacFiles" of scroll view "flacFiles" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to register drag types {"file names"}
	
	
	
	--tell of tab view "tabs" of window "mainWindow" to register drag types {"file names"}
	--	tell text view "decodeList" of scroll view "decodeList" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow" to register drag types {"file names"}
	--	display dialog "registered"
	--tell tab view "tabs" of window "mainWindow" to register drag types {"file names"}
	
	--if theObject's name is "testText" then
	--tell theObject to register drag types {"file names"}
	--display dialog "registered"
	--end if
	--end if
	
	
	
end awake from nib

on setPreferences()
	
	make new default entry at end of default entries of user defaults with properties {name:"encodeFormat", contents:"1,1"}
	make new default entry at end of default entries of user defaults with properties {name:"flacLevel", contents:"6"}
	make new default entry at end of default entries of user defaults with properties {name:"flacVerify", contents:"0"}
	make new default entry at end of default entries of user defaults with properties {name:"fixFormat", contents:"1"}
	make new default entry at end of default entries of user defaults with properties {name:"fixFlacLevel", contents:"6"}
	
	set encodeFormat to contents of default entry "encodeFormat" of user defaults
	set flacLevel to contents of default entry "flacLevel" of user defaults as number
	set flacVerify to contents of default entry "flacVerify" of user defaults as number
	set fixFormat to contents of default entry "fixFormat" of user defaults
	set fixFlacLevel to contents of default entry "fixFlacLevel" of user defaults as number
	
	
	
	set column to item 1 of encodeFormat as number
	set row to item 3 of encodeFormat as number
	
	set fixColumn to fixFormat as number
	
	set the current column of matrix "encodeFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to column
	set the current row of matrix "encodeFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to row
	set contents of slider "qualitySlider" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to flacLevel
	set the state of button "verifyCheckbox" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to flacVerify
	set the current column of matrix "fixFormat" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" to fixColumn
	set contents of slider "fixFlacSlider" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" to fixFlacLevel
	
	
end setPreferences

on will quit theObject
	
	set column to the current column of matrix "encodeFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow"
	set row to the current row of matrix "encodeFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow"
	set flacLevel to the contents of slider "qualitySlider" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" as integer
	set flacVerify to the state of button "verifyCheckbox" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow"
	set fixColumn to the current column of matrix "fixFormat" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow"
	set fixFlacLevel to the contents of slider "fixFlacSlider" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" as integer
	
	
	set contents of default entry "encodeFormat" of user defaults to column & "," & row
	set contents of default entry "flacLevel" of user defaults to flacLevel
	set contents of default entry "flacVerify" of user defaults to flacVerify
	set contents of default entry "fixFormat" of user defaults to fixColumn
	set contents of default entry "fixFlacLevel" of user defaults to fixFlacLevel
	
	HideWindow()
end will quit

on action theObject
	(*Add your script here.*)
end action

on closed theObject
	(*Add your script here.*)
end closed

on should close theObject
	(*Add your script here.*)
end should close

on opened theObject
	(*Add your script here.*)
end opened

on will resize theObject proposed size proposedSize
	(*Add your script here.*)
end will resize


on should open theObject
	(*Add your script here.*)
end should open

on mouse down theObject event theEvent
	(*Add your script here.*)
end mouse down

on panel ended theObject with result withResult
	(*Add your script here.*)
end panel ended

on selected tab view item theObject tab view item tabViewItem
	(*Add your script here.*)
	set theTagTab to tab view item "tagTab" of tab view "tabs" of window "mainWindow"
	
	displayRelevantOptions()
	
	if the current tab view item of tab view "tabs" of window "mainWindow" is equal to theTagTab then
		if tagPaths is equal to {} then
			setupDataSource()
		end if
	end if
end selected tab view item

on will finish launching theObject
end will finish launching


on selection changed theObject
	handleFlacTags()
	(*Add your script here.*)
end selection changed

on conclude drop theObject drag info dragInfo
	(* We need to have this handler do nothing to keep the text field from doing it's own drop. This is true for text view's as well. If you want to let the text field or text view do the actual drop you can remove the "conclude drop" event handler and then not do anything in the "drop" event handler. *)
end conclude drop

-- The "drop" event handler is called when the appropriate type of data is dropped onto the object. All of the pertinent information about the drop is contained in the "dragInfo" object.
--
on drop theObject drag info dragInfo
	-- Get the list of data types on the pasteboard
	set dataTypes to types of pasteboard of dragInfo
	
	-- We are only interested in either "file names" or "color" data types
	if "file names" is in dataTypes then
		-- Initialize the list of files to an empty list
		set theFiles to {}
		
		-- We want the data as a list of file names, so set the preferred type to "file names"
		set preferred type of pasteboard of dragInfo to "file names"
		
		-- Get the list of files from the pasteboard
		set theFiles to contents of pasteboard of dragInfo
		
		if (count of theFiles) > 0 then
			open (theFiles)
		end if
	end if
	
	-- Set the preferred type back to the default
	set preferred type of pasteboard of dragInfo to ""
	return true
end drop

on drag exited theObject drag info dragInfo
	(*Add your script here.*)
end drag exited

on drag theObject drag info dragInfo
	(*Add your script here.*)
end drag

on prepare drop theObject drag info dragInfo
	(*Add your script here.*)
end prepare drop

on drag updated theObject drag info dragInfo
	(*Add your script here.*)
end drag updated

on drag entered theObject drag info dragInfo
	(*Add your script here.*)
end drag entered


on will close theObject
end will close


on decompress(iPath, outputPath)
	
	if outputPath is null then
		set decodeOutputDir to get_Directory(iPath)
	else
		set decodeOutputDir to outputPath
	end if
	
	if iPath ends with ".flac" then
		try
			if the current row of matrix "selectFormat" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
				my convertFLACToAiff(iPath, decodeOutputDir)
			else
				my convertFLACToWav(iPath, decodeOutputDir)
			end if
			
		on error errorStr number errorNum
			display dialog ("error Decoding: " & iPath) buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to errorLog & iPath & ": " & errorStr & return
		end try
		
	else if iPath ends with ".shn" then
		try
			if the current row of matrix "selectFormat" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
				my convertSHNToAiff(iPath, decodeOutputDir)
			else
				my convertSHNToWav(iPath, decodeOutputDir)
			end if
			
			--error code when calling shorten directly.  shorten supplies the error in first line
		on error errorStr number errorNum
			set AppleScript's text item delimiters to "/"
			set fileName to the last text item of iPath
			set AppleScript's text item delimiters to return
			
			--error message from shorten is a line, followed by shorten version number and contact info.
			--we only want the first line (error)
			set theMsg to text item 1 of errorStr
			
			--now get rid of the "shorten:" which is at the beginning of error msg
			set AppleScript's text item delimiters to "shorten:"
			set theMsg to fileName & ": " & (the last text item of theMsg)
			
			display dialog theMsg buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to errorLog & theMsg & return
		end try
		--end error code when calling shorten directly
		
	else if iPath ends with ".ape" then
		try
			if the current row of matrix "selectFormat" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
				my convertAPEToAiff(iPath, decodeOutputDir)
			else
				my convertAPEToWav(iPath, decodeOutputDir)
			end if
		on error errorStr number errorNum
			set AppleScript's text item delimiters to return
			--set errorMsg to text item 2 of errorStr
			display dialog ("error Decoding: " & iPath) buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to errorLog & iPath & ": " & errorStr & return
			
		end try
		
	else if iPath ends with ".wv" then --wavpack files
		try
			if the current row of matrix "selectFormat" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
				my convertWavpackToAiff(iPath, decodeOutputDir)
			else
				my convertWavpackToWav(iPath, decodeOutputDir)
			end if
			
		on error errorStr number errorNum
			display dialog ("error Decoding: " & iPath) buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to errorLog & iPath & ": " & errorStr & return
		end try
	else if iPath ends with ".tta" then --TTA files
		try
			if the current row of matrix "selectFormat" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
				my convertTTAToAiff(iPath, decodeOutputDir)
			else
				my convertTTAToWav(iPath, decodeOutputDir)
			end if
			
		on error errorStr number errorNum
			display dialog ("error Decoding: " & iPath) buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to errorLog & iPath & ": " & errorStr & return
		end try
	else if (iPath ends with ".m4a") then
		try
			if the current row of matrix "selectFormat" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
				my convertALACToAiffOrWav(iPath, decodeOutputDir, "AIFF")
			else
				my convertALACToAiffOrWav(iPath, decodeOutputDir, "WAVE")
			end if
		on error errorStr number errorNum
			display dialog ("error Decoding: " & iPath) buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to errorLog & iPath & ": " & errorStr & return
		end try
	else
		display dialog "only .shn, .flac, .ape, .wv, .tta, and Apple Lossless files, please" buttons {"OK"} default button "OK" with icon 0 giving up after 20
	end if
end decompress

on convertFLACToAiff(iPath, outputPath)
	
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of iPath
	
	
	set AppleScript's text item delimiters to ".flac"
	set fileName to the first text item of fileName & ".aiff"
	
	
	set decodeThroughErrors to the state of button "decodeThroughErrors" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow"
	
	if decodeThroughErrors is equal to 0 then
		do shell script shellPath & "flac -s -d --force-aiff-format  " & getQuotedForm(iPath) & " -o " & getQuotedForm(outputPath & fileName)
	else
		do shell script shellPath & "flac -s -d  -F --force-aiff-format  " & getQuotedForm(iPath) & " -o " & getQuotedForm(outputPath & fileName)
		
	end if
end convertFLACToAiff

on convertFLACToWav(iPath, outputPath)
	
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of iPath
	set AppleScript's text item delimiters to ".flac"
	set fileName to the first text item of fileName & ".wav"
	
	set decodeThroughErrors to the state of button "decodeThroughErrors" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow"
	
	if decodeThroughErrors is equal to 0 then
		do shell script shellPath & "flac -s -d " & getQuotedForm(iPath) & " -o " & getQuotedForm(outputPath & fileName)
	else
		do shell script shellPath & "flac -s -d -F" & getQuotedForm(iPath) & " -o " & getQuotedForm(outputPath & fileName)
	end if
end convertFLACToWav

on convertSHNToAiff(iPath, outputPath)
	--	--old code that used shntool to convert shn to aiff
	--	set theResult to do shell script shellPath & "shntool conv -o aiff -d " & outputPath & space & iPath & " 2>&1"
	--	
	--	--i *think* that sanity check errors will only show up as warnings and
	--	--preamture EOF on compressed stream errors will show up as errors	
	--	if theResult contains "warning:" and theResult does not contain "error:" then
	--		set AppleScript's text item delimiters to return
	--		display dialog theResult buttons {"OK"} default button "OK" with icon 0 giving up after 20
	--		set errorLog to errorLog & return & iPath & ": " & theResult & return
	--		
	--	end if
	--	--end old code that used shntool to convert shn to aiff
	
	--begin new code to convert to aiff explicitly calling sox
	--1. convert shn to temporary wav by calling shorten -x
	--2. convert temporary wav to aiff calling sox
	--3. delete temporary wav
	
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of iPath
	
	--remove the .shn from the filename
	set fileName to get_fileName_no_extension(fileName)
	set fileNameConverted to "tempxACTConvert.wav"
	
	--try
	--decode shn to temp wav
	set theCommand to shellPath & "shorten -x " & getQuotedForm(iPath) & space & getQuotedForm(outputPath & fileNameConverted) & " 2>&1"
	set theResult to do shell script theCommand
	
	--convert temp wav to aiff
	try
		set convertCommand to shellPath & "sox " & getQuotedForm(outputPath & fileNameConverted) & space & getQuotedForm(outputPath & fileName & ".aiff") & " 2>&1"
		do shell script convertCommand
		--now delete temp file
		--do shell script "mv " & outputPath & fileNameConverted & space & "~/.Trash"
		do shell script "rm " & getQuotedForm(outputPath & fileNameConverted)
	on error errorStr number errorNum
		--convert to aiff failed, so delete the temp wav first before displaying error
		do shell script "rm " & getQuotedForm(outputPath & fileNameConverted)
		display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
		
		--			set errorLog to errorStr & ": " & getMACError(errorStr) & return
		set AppleScript's text item delimiters to "/"
		set fileName to the last text item of iPath
		set errorLog to errorLog & return & "Error converting " & fileName & ": " & return & errorStr & return
	end try
	
end convertSHNToAiff

on convertSHNToWav(iPath, outputPath)
	--	--old code that used shntool to decode to wav
	--	set theResult to do shell script shellPath & "shntool conv -o wav -d " & outputPath & space & iPath & " 2>&1"
	--	
	--	--i *think* that sanity check errors will only show up as warnings and
	--	--preamture EOF on compressed stream errors will show up as errors
	--	if theResult contains "warning:" and theResult does not contain "error:" then
	--		set AppleScript's text item delimiters to return
	--		display dialog theResult buttons {"OK"} default button "OK" with icon 0 giving up after 20
	--		set errorLog to errorLog & return & iPath & ": " & theResult & return
	--		
	--	end if
	--	--end old code to use shntool to convert to wav
	
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of iPath
	
	--remove the .shn from the filename
	set fileName to get_fileName_no_extension(fileName)
	
	set theCommand to shellPath & "shorten -x " & getQuotedForm(iPath) & space & getQuotedForm(outputPath & fileName & ".wav") & " 2>&1"
	--set theCommand to shellPath & "shntool conv -o wav -d " & getQuotedForm(outputPath) & space & getQuotedForm(iPath) & " 2>&1"
	--display dialog theCommand
	--makeMessageWindow(theCommand)
	set theResult to do shell script theCommand
	
end convertSHNToWav


on convertWavpackToAiff(iPath, outputPath)
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of iPath
	
	set sixteenBit to check16Bit(iPath)
	
	if sixteenBit is equal to false or sixteenBit is equal to "unknown" then
		set theMessage to "wavpack file is not 16 bit.  If attempting to decode a 24 bit .wv file, please convert to wav first.  xACT can't convert 24 bit .wv to .aiff."
		display dialog theMessage buttons {"OK"} default button "OK" with icon 0 giving up after 20
		set errorLog to errorLog & return & iPath & ": " & theMessage & return
	else
		--remove the .wv from the filename
		set fileName to get_fileName_no_extension(fileName)
		
		--set theResult to do shell script shellPath & "wvunpack -y " & iPath & space & outputPath & fileName & ".wav 2>&1"
		set theCommand to shellPath & "shntool conv -O never -o aiff -P none -d " & getQuotedForm(outputPath) & space & getQuotedForm(iPath) & " 2>&1"
		set theResult to do shell script theCommand
		
	end if
	
end convertWavpackToAiff

on convertWavpackToWav(iPath, outputPath)
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of iPath
	
	--remove the .wv from the filename
	set fileName to get_fileName_no_extension(fileName)
	
	--set theResult to do shell script shellPath & "wvunpack -y " & iPath & space & outputPath & fileName & ".wav 2>&1"
	set theCommand to shellPath & "shntool conv -O never -o wav -P none -d " & getQuotedForm(outputPath) & space & getQuotedForm(iPath) & " 2>&1"
	set theResult to do shell script theCommand
	
end convertWavpackToWav


on convertTTAToAiff(iPath, outputPath)
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of iPath
	
	--set fileDir to get_Directory(iPath)
	
	--remove the .tta from the filename
	set fileName to get_fileName_no_extension(fileName)
	set fileNameConverted to "tempxACTConvert.wav"
	
	try
		--set theResult to do shell script shellPath & "mac " & iPath & space & outputPath & fileNameConverted & " -d" & space & " 2>&1"
		set theCommand to "cd " & getQuotedForm(outputPath) & " ; " & shellPath & "ttaenc -d " & getQuotedForm(iPath) & " 2>&1"
		set theResult to do shell script theCommand
		
		--now convert the wav to aiff
		try
			set convertCommand to shellPath & "sox " & getQuotedForm(outputPath & fileNameConverted) & space & getQuotedForm(outputPath & fileName & ".aiff") & " 2>&1"
			do shell script convertCommand
			--now delete temp filew
			--do shell script "mv " & outputPath & fileNameConverted & space & "~/.Trash"
			do shell script "rm " & getQuotedForm(outputPath & fileNameConverted)
		on error errorStr number errNum
			set errMsg to "unable to decode to aiff(possibly 24 bit?).  Try converting to wav instead."
			display dialog errMsg buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to errorLog & errorStr & return
			--delete the temp file
			--do shell script "mv " & outputPath & fileNameConverted & space & "~/.Trash"
			do shell script "rm " & getQuotedForm(outputPath & fileNameConverted)
		end try
		
	on error errorStr number errNum
		set AppleScript's text item delimiters to "/"
		set fileName to the last text item of iPath
		set errMsg to "unable to decode " & fileName
		display dialog errMsg buttons {"OK"} default button "OK" with icon 0 giving up after 20
		--		set errorLog to errorLog & fileName & ": " & return & errorStr & ": " & getMACError(errorStr) & return
		set errorLog to errorLog & "Error decoding: " & fileName & ": " & return --& parseAPEError(errorStr) & return
	end try
	
end convertTTAToAiff

on convertTTAToWav(iPath, outputPath)
	set fileDir to get_Directory(iPath)
	
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of iPath
	
	--remove the .tta from the filename
	set fileName to get_fileName_no_extension(fileName)
	
	set theCommand to "cd " & getQuotedForm(outputPath) & " ; " & shellPath & "ttaenc -d " & getQuotedForm(iPath) & " 2>&1"
	set theResult to do shell script theCommand
	
end convertTTAToWav

on convertALACToAiffOrWav(iPath, outputPath, format)
	--afconvert  -d 'aiff' -v input wav output m4a
	--afconvert  -d 'wav' -v input wav output m4a
	
	set bitrate to getAlacBitrate(iPath)
	if bitrate is equal to "16-bit" then
		set bitrate to "16"
	else if bitrate is equal to "24-bit" then
		set bitrate to 24
	else
		display dialog "only 16 or 24 bit Apple Lossless is supported"
		return
	end if
	
	set dataFormat to ""
	set fileExtension to ""
	if format is equal to "WAVE" then
		set fileExtension to ".wav"
		set dataFormat to "LEI" & bitrate
	else
		set fileExtension to ".aiff"
		set dataFormat to "BEI" & bitrate
	end if
	
	--get the filename (no path)
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of iPath
	
	--if the filename has an extension, we want to drop it
	if fileName contains "." then
		set fileName to get_fileName_no_extension(fileName)
	end if
	
	--	set AppleScript's text item delimiters to "."
	--	set fileExtension to the last text item of iPath
	
	set theCommand to shellPath & "afconvert -f " & format & " -d " & dataFormat & " -v " & getQuotedForm(iPath) & space & getQuotedForm(outputPath & fileName & fileExtension) & space & " 2>&1"
	
	set theResult to (do shell script theCommand)
	if theResult contains "error" then
		display dialog theResult buttons {"OK"} default button "OK" with icon 0 giving up after 20
		set errorLog to theResult & return
	end if
	
	
	makeMessageWindow(theResult)
	
	return theResult
end convertALACToAiffOrWav

on convertAPEToAiff(iPath, outputPath)
	--begin new code to call mac directly and use sox to convert to aiff
	
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of iPath
	
	--remove the .ape from the filename
	set fileName to get_fileName_no_extension(fileName)
	set fileNameConverted to "tempxACTConvert.wav"
	
	try
		if pantherFlag is equal to true then
			set theResult to do shell script shellPath & "mac " & getQuotedForm(iPath) & space & getQuotedForm(outputPath & fileNameConverted) & " -d" & space & " 2>&1"
		else
			set theResult to do shell script shellPath & "jaguarmac " & getQuotedForm(iPath) & space & getQuotedForm(outputPath & fileNameConverted) & " -d" & space & " 2>&1"
		end if
		--now convert the wav to aiff
		try
			set convertCommand to shellPath & "sox " & getQuotedForm(outputPath & fileNameConverted) & space & getQuotedForm(outputPath & fileName & ".aiff") & " 2>&1"
			do shell script convertCommand
			--now delete temp filew
			--do shell script "mv " & outputPath & fileNameConverted & space & "~/.Trash"
			do shell script "rm " & getQuotedForm(outputPath & fileNameConverted)
		on error errorStr number errNum
			set errMsg to "unable to decode to aiff(possibly 24 bit?).  Try converting to wav instead."
			display dialog errMsg buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to errorLog & errorStr & return
			--delete the temp file
			--do shell script "mv " & outputPath & fileNameConverted & space & "~/.Trash"
			do shell script "rm " & getQuotedForm(outputPath & fileNameConverted)
		end try
		
	on error errorStr number errNum
		set AppleScript's text item delimiters to "/"
		set fileName to the last text item of iPath
		set errMsg to "unable to decode " & fileName
		display dialog errMsg buttons {"OK"} default button "OK" with icon 0 giving up after 20
		--		set errorLog to errorLog & fileName & ": " & return & errorStr & ": " & getMACError(errorStr) & return
		set errorLog to errorLog & "Error decoding: " & fileName & ": " & return & parseAPEError(errorStr) & return
	end try
	
	
	
	
end convertAPEToAiff

on convertAPEToWav(iPath, outputPath)
	--previous code that used shntool to convert ape to wav-----------------------
	--	set theResult to do shell script shellPath & "shntool conv -o wav -d " & outputPath & space & iPath & " 2>&1"
	--	if theResult contains "warning" and theResult does not contain "error:" then
	--		set AppleScript's text item delimiters to return
	--		--set errorStr to text item 2 of theResult
	--		display dialog ("problem decoding" & iPath) buttons {"OK"} default button "OK" with icon 0 giving up after 20
	--		set errorLog to errorLog & return & iPath & ": " & theResult & return
	--		
	--	end if
	--end previous code--------------------------------------------------------------
	--begin new code to call mac directly-------------------------------------------
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of iPath
	--remove the .ape from the filename
	set fileName to get_fileName_no_extension(fileName)
	
	try
		if pantherFlag is equal to true then
			set theResult to do shell script shellPath & "mac " & getQuotedForm(iPath) & space & getQuotedForm(outputPath & fileName & ".wav") & " -d" & space & " 2>&1"
		else
			set theResult to do shell script shellPath & "jaguarmac " & getQuotedForm(iPath) & space & getQuotedForm(outputPath & fileName & ".wav") & " -d" & space & " 2>&1"
		end if
	on error errorStr number errNum
		set AppleScript's text item delimiters to "/"
		set fileName to the last text item of iPath
		set errMsg to "unable to decode " & fileName
		display dialog errMsg buttons {"OK"} default button "OK" with icon 0 giving up after 20
		--	set errorLog to errorLog & errorStr & ": " & getMACError(errorStr) & return
		set errorLog to errorLog & "Error decoding: " & fileName & ": " & return & parseAPEError(errorStr) & return
	end try
end convertAPEToWav

on fingerprint(iPath)
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of iPath
	
	set theResult to do shell script shellPath & "metaflac --show-md5 " & getQuotedForm(iPath)
	
	set theFingerprints to theFingerprints & (de_unix_path(fileName) & ":" & theResult)
end fingerprint

on verifyFlac(iPath)
	set theResult to do shell script shellPath & "flac -t " & getQuotedForm(iPath) & " 2>&1"
	set theResult to parseFLACVerify(theResult)
	return theResult
end verifyFlac

on verifyWavpack(iPath)
	set theResult to do shell script shellPath & "wvunpack -v " & getQuotedForm(iPath) & " 2>&1"
	set theResult to parseWavpackVerify(theResult)
	return theResult
end verifyWavpack


on verifyAPE(iPath)
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of iPath
	
	try
		if pantherFlag is equal to true then
			set theResult to do shell script shellPath & "mac " & getQuotedForm(iPath) & " -v 2>&1"
		else
			set theResult to do shell script shellPath & "jaguarmac " & getQuotedForm(iPath) & " -v 2>&1"
		end if
		set theResult to fileName & ":" & return & parseAPEVerify(theResult)
		return theResult
		
		--moved from calling method
	on error errorStr number errorNum
		set theResult to ""
		if errorStr contains "Progress:" then
			if errorStr contains "Success" then
				set theResult to fileName & ":" & return & parseAPEVerify(errorStr)
			else
				--failed
				set theResult to fileName & ":" & return & parseAPEVerify(errorStr) & "Failed..."
			end if
		else
			--error before even checking. parse message
			set theResult to theResult & fileName & ": " & return & parseAPEError(errorStr) & return & "Failed..." & return
		end if
		return theResult
	end try
end verifyAPE


on compress(iPath, outputPath)
	
	if outputPath is null then
		set encodeOutputDir to get_Directory(iPath)
	else
		set encodeOutputDir to outputPath
	end if
	
	--column 1 is shn, flac, ape
	if the current column of matrix "encodeFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
		if the current row of matrix "encodeFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
			try
				my convertToSHN(iPath, encodeOutputDir)
			on error errorStr number errorNum
				display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
				set errorLog to errorLog & return & iPath & ": " & errorStr & return
				
			end try
			
			--else if flac	
		else if the current row of matrix "encodeFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" is equal to 2 then
			try
				if iPath contains ".shn" then
					convertShnToFlac(iPath, encodeOutputDir)
				else
					my convertToFlac(iPath, encodeOutputDir)
				end if
			on error errorStr number errorNum
				display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
				set errorLog to errorLog & return & iPath & ": " & errorStr & return
				
			end try
			
			--else if ape
		else if the current row of matrix "encodeFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" is equal to 3 then
			try
				my convertToApe(iPath, encodeOutputDir)
			on error errorStr number errorNum
				display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
				set errorLog to errorLog & return & iPath & ": " & errorStr & return
			end try
		end if
	else --column 2 is wavpack, tta, Apple Lossless
		--wavpack
		if the current row of matrix "encodeFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
			try
				my convertToWavpack(iPath, encodeOutputDir)
			on error errorStr number errorNum
				display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
				set errorLog to errorLog & return & iPath & ": " & errorStr & return
			end try
		else if the current row of matrix "encodeFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" is equal to 2 then
			--TTA
			try
				my convertToTTA(iPath, encodeOutputDir)
			on error errorStr number errorNum
				if errorStr contains "[2KError:   file(s) not found" then
					
				else
					display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
					set errorLog to errorLog & return & iPath & ": " & errorStr & return
				end if
			end try
		else if the current row of matrix "encodeFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" is equal to 3 then
			try
				my convertToALAC(iPath, encodeOutputDir)
			on error errorStr number errorNum
				display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
				set errorLog to errorLog & return & iPath & ": " & errorStr & return
			end try
		end if
	end if
	
end compress

on convertShnToFlac(iPath, outputPath)
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of iPath
	
	set flacLevel to the contents of slider "qualitySlider" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" as integer
	
	--set theCommand to shellPath & "shntool fix -O never -o cust ext=flac { flac -s -" & flacLevel & " -o %f - }" & space & "-d " & outputPath & space & theFiles & " 2>&1"
	
	set theCommand to shellPath & "shntool conv -O never -P none -o 'cust ext=flac flac -s -" & flacLevel & " -o %f -' -d " & getQuotedForm(outputPath) & space & getQuotedForm(iPath)
	
	do shell script theCommand
	
end convertShnToFlac


on convertToFlac(iPath, outputPath)
	
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of iPath
	
	if fileName contains ".aif" or fileName contains ".wav" then
		set fileName to get_fileName_no_extension(fileName)
	end if
	
	set fileName to fileName & ".flac"
	
	set verify to the state of button "verifyCheckbox" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow"
	set lax to the state of button "laxCheckbox" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow"
	
	
	
	if verify is equal to 1 then
		set verifyString to "-V"
	else
		set verifyString to ""
	end if
	
	if lax is equal to 1 then
		set theCommand to shellPath & "flac --lax " & verifyString & space & getQuotedForm(iPath) & " -o " & getQuotedForm(outputPath & fileName)
		
	else
		set num to the contents of slider "qualitySlider" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" as integer
		
		set theCommand to shellPath & "flac -" & num & space & verifyString & space & getQuotedForm(iPath) & " -o " & getQuotedForm(outputPath & fileName)
	end if
	
	
	
	try
		do shell script theCommand
	on error errorStr number errorNum
		--see if it's an aifc file and try to convert that
		--if errorStr contains "is not a AIFF file" then
		--	convertAIFCToFLAC(iPath, outputPath, num, verifyString)
		--else --it's an error
		display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
		set errorLog to errorLog & return & iPath & ": " & errorStr & return
		
		--end if
	end try
	
end convertToFlac

on convertToSHN(iPath, outputPath)
	
	set theCommand to shellPath & "shntool conv -o shn -P none -O never -d " & getQuotedForm(outputPath) & space & getQuotedForm(iPath) & " 2>&1"
	
	set theResult to do shell script theCommand
	if theResult contains "is not handled by" then
		--set AppleScript's text item delimiters to "."
		--set fileExtension to the last text item of iPath
		--if fileExtension contains "aif" then
		--	--maybe it's AIFC?
		--	convertAIFCToSHN(iPath, outputPath)
		--else
		display dialog theResult buttons {"OK"} default button "OK" with icon 0 giving up after 20
		set errorLog to theResult & return
		--end if
	else
		set MD5Paths to MD5Paths & getEncodedFileNames(theResult)
	end if
end convertToSHN

on convertToWavpack(iPath, outputPath)
	
	--set wavpack level
	set wavpackLevel to ""
	if the current column of matrix "wavpackFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
		set wavpackLevel to "-f"
	else
		set wavpackLevel to "-h"
	end if
	
	set theCommand to shellPath & "shntool conv -O never -P none -o 'cust ext=wv wavpack " & wavpackLevel & " -m - %f ' " & space & "-d " & getQuotedForm(outputPath) & space & getQuotedForm(iPath) & " 2>&1"
	
	set theResult to do shell script theCommand
	if theResult contains "is not handled by" then
		--set AppleScript's text item delimiters to "."
		--set fileExtension to the last text item of iPath
		--if fileExtension contains "aif" then
		--	--maybe it's AIFC?
		--	convertAIFCTowavpack(iPath, outputPath, wavpackLevel)
		--else
		display dialog theResult buttons {"OK"} default button "OK" with icon 0 giving up after 20
		set errorLog to theResult & return
		--end if
		--else
		--	set MD5Paths to MD5Paths & getEncodedFileNames(theResult)
	end if
end convertToWavpack

on convertToTTA(iPath, outputPath)
	
	set fileName to the last text item of iPath
	if fileName contains ".aif" or fileName contains ".wav" then
		set fileName to get_fileName_no_extension(fileName)
	end if
	
	set fileFormat to checkFormat(iPath)
	set sixteenBit to check16Bit(iPath)
	
	set fileDir to get_Directory(iPath)
	
	set theCommand to ""
	if fileFormat is equal to "wav" then
		set theCommand to "cd " & getQuotedForm(fileDir) & " ; " & shellPath & "ttaenc -e " & getQuotedForm(iPath) & " 2>&1"
		set theResult to do shell script theCommand
		
	else if fileFormat is equal to "aiff" and sixteenBit is equal to true then
		--convert this file to wav
		set fileNameConverted to "tempxACTConvert.wav"
		
		
		set convertCommand to shellPath & "sox " & getQuotedForm(iPath) & space & getQuotedForm(outputPath & fileNameConverted)
		do shell script convertCommand
		set theCommand to "cd " & getQuotedForm(fileDir) & " ; " & shellPath & "ttaenc -e -o " & getQuotedForm(fileName) & ".tta" & space & getQuotedForm(outputPath & fileNameConverted) & " 2>&1"
		
		set theResult to do shell script theCommand
		
		--now delete temp file
		--do shell script "mv " & outputPath & fileNameConverted & space & "~/.Trash"
		do shell script "rm " & getQuotedForm(outputPath & fileNameConverted)
	else if fileFormat is equal to "aiff" and sixteenBit is equal to false then
		set theMessage to "only 16 bit aiffs can be compressed to tta.  for 24 bit, convert to wav first"
		display dialog theMessage buttons {"OK"} default button "OK" with icon 0 giving up after 20
		set errorLog to errorLog & return & iPath & ": " & theMessage & return
	else if fileFormat is equal to "other" then
		set theMessage to "only .wav or .aiff files can be compressed to .tta"
		display dialog theMessage buttons {"OK"} default button "OK" with icon 0 giving up after 20
		set errorLog to errorLog & return & iPath & ": " & theMessage & return
	else if fileFormat is equal to "unknown" then
		set theMessage to "unknown file format or AIFC-compressed.  cannot compress to .tta"
		display dialog theMessage buttons {"OK"} default button "OK" with icon 0 giving up after 20
		set errorLog to errorLog & return & iPath & ": " & theMessage & return
	end if
	
end convertToTTA

--on convertAIFCToSHN(iPath, outputPath)
--	--right now, if we got here, it means the file extension was aif, aiff or aifc.  so no need to check for an extension before stripping it
--	set AppleScript's text item delimiters to "/"
--	set fileName to the last text item of iPath
--	set fileName to get_fileName_no_extension(fileName)
--	
--	set fileNameConverted to "tempxACTConvert.wav"
--	
--	--try to convert aifc to wav
--	try
--		set convertCommand to shellPath & "aifc2wav " & getQuotedForm(iPath) & space & getQuotedForm(outputPath & fileNameConverted) & " 2>&1"
--		do shell script convertCommand
--		
--		--now convert the wav to shn
--		set theCommand to shellPath & "shorten " & getQuotedForm(outputPath & fileNameConverted) & space & getQuotedForm(outputPath & fileName & ".shn") & " 2>&1"
--		set theResult to do shell script theCommand
--		
--		do shell script "rm " & getQuotedForm(outputPath & fileNameConverted)
--		
--	on error errorStr number errorNum
--		display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
--		
--		set AppleScript's text item delimiters to "/"
--		set fileName to the last text item of iPath
--		set errorLog to errorLog & return & "Error converting " & fileName & ": " & return & errorStr & return
--		
--	end try
--end convertAIFCToSHN

--on convertAIFCTowavpack(iPath, outputPath, wavpackLevel)
--	--right now, if we got here, it means the file extension was aif, aiff or aifc.  so no need to check for an extension before stripping it
--	set AppleScript's text item delimiters to "/"
--	set fileName to the last text item of iPath
--	set fileName to get_fileName_no_extension(fileName)
--	
--	set fileNameConverted to "tempxACTConvert.wav"
--	
--	--try to convert aifc to wav
--	try
--		set convertCommand to shellPath & "aifc2wav " & getQuotedForm(iPath) & space & getQuotedForm(outputPath & fileNameConverted) & " 2>&1"
--		do shell script convertCommand
--		
--		--now convert the wav to wavpack (wv)
--		
--		set theCommand to shellPath & "wavpack " & wavpackLevel & " -m " & getQuotedForm(outputPath & fileNameConverted) & space & getQuotedForm(outputPath & fileName & ".wv") & " 2>&1"
--		
--		set theResult to do shell script theCommand
--		
--		do shell script "rm " & getQuotedForm(outputPath & fileNameConverted)
--		
--	on error errorStr number errorNum
--		display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
--		
--		set AppleScript's text item delimiters to "/"
--		set fileName to the last text item of iPath
--		set errorLog to errorLog & return & "Error converting " & fileName & ": " & return & errorStr & return
--		
--	end try
--end convertAIFCTowavpack

--on convertAIFCToFLAC(iPath, outputPath, num, verifyString)
--	--if we got here, it means that flac choked on encoding something it thought was an aiff file. 
--	--file extension was aif, aiff or aifc.  so no need to check for an extension before stripping it
--	
--	set AppleScript's text item delimiters to "/"
--	set fileName to the last text item of iPath
--	set fileName to get_fileName_no_extension(fileName)
--	
--	set fileNameConverted to "tempxACTConvert.wav"
--	
--	--try to convert aifc to wav
--	try
--		set convertCommand to shellPath & "aifc2wav " & getQuotedForm(iPath) & space & getQuotedForm(outputPath & fileNameConverted) & " 2>&1"
--		do shell script convertCommand
--		
--		--now convert the wav to shn
--		--set theCommand to shellPath & "shorten " & outputPath & fileNameConverted & space & outputPath & fileName & ".shn" & " 2>&1"
--		
--		set theCommand to shellPath & "flac -" & num & space & verifyString & space & getQuotedForm(outputPath & fileNameConverted) & " -o " & getQuotedForm(outputPath & fileName & ".flac") & " 2>&1"
--		
--		set theResult to do shell script theCommand
--		
--		do shell script "rm " & getQuotedForm(outputPath & fileNameConverted)
--		
--	on error errorStr number errorNum
--		display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
--		
--		set AppleScript's text item delimiters to "/"
--		set fileName to the last text item of iPath
--		set errorLog to errorLog & return & "Error converting " & fileName & ": " & return & errorStr & return
--		
--	end try
--end convertAIFCToFLAC

on convertToApe(iPath, outputPath)
	set num to the contents of slider "apeSlider" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" as integer
	
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of iPath
	if fileName contains ".aif" or fileName contains ".wav" then
		set fileName to get_fileName_no_extension(fileName)
	end if
	
	set fileFormat to checkFormat(iPath)
	set sixteenBit to check16Bit(iPath)
	
	try
		if fileFormat is equal to "wav" then
			
			if pantherFlag is equal to true then
				set theCommand to shellPath & "mac " & getQuotedForm(iPath) & space & getQuotedForm(outputPath & fileName & ".ape") & " -c" & num & " 2>&1"
			else
				set theCommand to shellPath & "jaguarmac " & getQuotedForm(iPath) & space & getQuotedForm(outputPath & fileName & ".ape") & " -c" & num & " 2>&1"
			end if
			
			set theResult to do shell script theCommand
			
		else if fileFormat is equal to "aiff" and sixteenBit is equal to true then
			--convert this file to wav
			set fileNameConverted to "tempxACTConvert.wav"
			set convertCommand to shellPath & "sox " & getQuotedForm(iPath) & space & getQuotedForm(outputPath & fileNameConverted)
			do shell script convertCommand
			if pantherFlag is equal to true then
				set theCommand to shellPath & "mac " & getQuotedForm(outputPath & fileNameConverted) & space & getQuotedForm(outputPath & fileName & ".ape") & " -c" & num & " 2>&1"
			else
				set theCommand to shellPath & "jaguarmac " & getQuotedForm(outputPath & fileNameConverted) & space & getQuotedForm(outputPath & fileName & ".ape") & " -c" & num & " 2>&1"
			end if
			set theResult to do shell script theCommand
			
			--now delete temp file
			--do shell script "mv " & outputPath & fileNameConverted & space & "~/.Trash"
			do shell script "rm " & getQuotedForm(outputPath & fileNameConverted)
		else if fileFormat is equal to "aiff" and sixteenBit is equal to false then
			set theMessage to "AIFF input file is not 16 bit.  If attempting to convert a 24 bit aiff to .ape, please convert to wav first.  Only 24 bit wavs can be converted to .ape."
			display dialog theMessage buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to errorLog & return & iPath & ": " & theMessage & return
		else if fileFormat is equal to "other" then
			set theMessage to "only .wav or .aiff files can be compressed to .ape"
			display dialog theMessage buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to errorLog & return & iPath & ": " & theMessage & return
		else if fileFormat is equal to "unknown" then
			set theMessage to "unknown file format or AIFC-compressed.  cannot compress to .ape"
			display dialog theMessage buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to errorLog & return & iPath & ": " & theMessage & return
		end if
		
	on error errorStr number errorNum
		display dialog "error" & getMACError(errorStr) buttons {"OK"} default button "OK" with icon 0 giving up after 20
		
		--			set errorLog to errorStr & ": " & getMACError(errorStr) & return
		set AppleScript's text item delimiters to "/"
		set fileName to the last text item of iPath
		set errorLog to errorLog & return & "Error converting " & fileName & ": " & return & parseAPEError(errorStr) & return
		
	end try
end convertToApe

on convertToALAC(iPath, outputPath)
	--afconvert -f 'm4af' -d 'alac' -v input wav output m4a
	
	set fileToEncode to iPath
	
	--get the filename (no path)
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of iPath
	
	--if the filename has an extension, we want to drop it
	if fileName contains "." then
		set fileName to get_fileName_no_extension(fileName)
	end if
	
	set AppleScript's text item delimiters to "."
	set fileExtension to the last text item of iPath
	
	set fileNameConverted to ""
	if fileExtension is "flac" or fileExtension is "shn" then
		--need to convert to wav first
		set fileNameConverted to fileName & ".wav"
		try
			set convertCommand to shellPath & "shntool conv -P none -O never -o wav -d " & getQuotedForm(outputPath) & space & getQuotedForm(iPath) & " 2>&1"
			do shell script convertCommand
			
			set fileToEncode to outputPath & fileNameConverted
		on error errorStr number errNum
			set errMsg to "unable to decode to wav before encoding to ALAC"
			display dialog errMsg buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to errorLog & errorStr & return
			do shell script "rm " & getQuotedForm(outputPath & fileNameConverted)
			return
		end try
	end if
	
	set theCommand to shellPath & "afconvert -d alac -v " & getQuotedForm(fileToEncode) & space & getQuotedForm(outputPath & fileName & ".m4a") & space & " 2>&1"
	
	set theResult to do shell script theCommand
	if theResult contains "error" then
		display dialog theResult buttons {"OK"} default button "OK" with icon 0 giving up after 20
		set errorLog to theResult & return
	end if
	
	--	if we converted a file to wav first from flac or shn, we need to delete it
	if fileNameConverted is not equal to "" then
		do shell script "rm " & getQuotedForm(fileToEncode)
	end if
	
	makeMessageWindow(theResult)
	
	return theResult
	--end if
end convertToALAC

on handleCheckMD5()
	set AppleScript's text item delimiters to "/"
	set theResult to ""
	
	--set filePath to the first item of MD5Paths as unicode text
	repeat with i in MD5Paths
		set filePath to i as Unicode text
		
		--for now, the check for a shntool md5 file is just going on filename having a .shntool.md5 in it
		if filePath contains ".st5" or filePath contains ".shntool.md5" then
			set theResult to theResult & return & return & checkShntoolMd5(filePath)
		else
			set theResult to theResult & return & return & checkTraditionalMd5(filePath)
		end if
		
	end repeat
	makeMessageWindow(theResult)
	
	set contents of text view "checksumList" of scroll view "checksumList" of view of tab view item "checksumTab" of tab view "tabs" of window "mainWindow" to ""
	set md5CheckFlag to false
	set MD5Paths to {} as list
	
	bounceDock()
end handleCheckMD5

on checkTraditionalMd5(filePath)
	set theResult to ""
	--need to grab the directory path only from filePath
	set fileDir to get_Directory(filePath)
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of filePath
	
	--	set theResult to ""
	
	----------------------------
	set theStatusPanel to load panel "StatusPanel" from nib "StatusPanel"
	display panel theStatusPanel attached to window "MainWindow"
	
	tell theStatusPanel
		tell progress indicator "progressbar"
			set uses threaded animation to true
			set indeterminate to true
			start
		end tell
		set AppleScript's text item delimiters to "/"
		set statusMessage to "Checking MD5 " & fileName & "...  "
		set contents of text field "statusMessage" to statusMessage
		call method "display" of text field "statusMessage"
	end tell
	
	
	
	
	try
		set theResult to "md5 check:" & return & return & (do shell script get_Shell_Dir(getQuotedForm(fileDir)) & "md5sum -c " & getQuotedForm(fileName) & " 2>&1")
	on error errorStr number errorNum
		display dialog "error" buttons {"OK"} default button "OK" with icon 0 giving up after 20
		set theResult to errorStr & return
		
	end try
	tell progress indicator "progressbar" of window "StatusPanel" to stop
	close panel window "StatusPanel"
	
	return theResult
	
end checkTraditionalMd5

on checkShntoolMd5(filePath)
	set theResults to ""
	
	set fileDir to get_Directory(filePath)
	
	set theStatusPanel to load panel "StatusPanel" from nib "StatusPanel"
	display panel theStatusPanel attached to window "MainWindow"
	
	tell theStatusPanel
		tell progress indicator "progressbar"
			set uses threaded animation to true
			set indeterminate to true
			start
		end tell
		set AppleScript's text item delimiters to "/"
		set statusMessage to "Checking shntool MD5 " & "...  "
		set contents of text field "statusMessage" to statusMessage
		call method "display" of text field "statusMessage"
	end tell
	
	
	
	--so we have directory now of where the fingerprint file is.  must be in same dir of flac files being checked
	--shntool md5 format =     md5hash  [shntool]  filename
	--go through file
	--parse each line for hash and filename
	--get hash for the filename and compare to one in file
	
	
	--shell scripts auto-convert to mac line endings.  call cat instead of reading file directly
	set theData to do shell script "cat " & getQuotedForm(filePath)
	
	set theResults to "shntool md5 check:" & return & return
	
	set theDelimiter to return
	set AppleScript's text item delimiters to theDelimiter
	repeat with i from 1 to (the number of text items in theData)
		set theLine to text item i of theData
		
		set AppleScript's text item delimiters to "  [shntool]  "
		set theMd5Hash to the first text item of theLine
		set theFilename to the last text item of theLine
		
		--if the filename has a space or other character, we need to deal with that
		set theFilename to unix_path(theFilename)
		
		set theResult to ""
		try
			set theResult to do shell script get_Shell_Dir(getQuotedForm(fileDir)) & "shntool hash " & getQuotedForm(theFilename) & " 2>&1"
			set AppleScript's text item delimiters to "  [shntool]  "
			set resultMd5Hash to the first text item of theResult
			set resultFilename to the last text item of theResult
			
			
			
			if theFilename is not equal to "" and resultMd5Hash is equal to theMd5Hash then
				set theResults to theResults & theFilename & ": OK" & return
			else if theFilename is not equal to "" and resultMd5Hash is not equal to theMd5Hash then
				set theResults to theResults & theFilename & ": did not match shntool md5 file" & return
			end if
		on error errorStr
			set theResults to theResults & theFilename & ": Error reading checksum.  file may be missing or corrupt" & return
		end try
		set AppleScript's text item delimiters to theDelimiter
		
	end repeat
	
	tell progress indicator "progressbar" of window "StatusPanel" to stop
	close panel window "StatusPanel"
	
	return theResults
end checkShntoolMd5

on handleCheckFingerprint()
	set AppleScript's text item delimiters to "/"
	set theResults to ""
	--	set filePath to the first item of fingerprintPaths as unicode text
	repeat with i in fingerprintPaths
		set filePath to i as Unicode text
		
		--need to grab the directory path only from filePath
		set fileDir to get_Directory(filePath)
		
		--so we have directory now of where the fingerprint file is.  must be in same dir of flac files being checked
		--fingerprint format =     filename: fingerprint OR filename:fingerprint
		--go through file
		--parse each line for filename and fingerprint
		--returnedFingerprint = metaflac --show-md5sum filename
		--compare to fingerprint
		
		--set filePath to de_unix_path(filePath)
		
		--set theFile to open for access filePath as POSIX file
		--set theData to read theFile as unicode text
		--close access theFile
		
		--shell scripts auto-convert to mac line endings.  call cat instead of reading file directly
		set theData to (do shell script "cat " & getQuotedForm(filePath))
		
		set theResults to theResults & return & "Fingerprint file check" & return & return
		
		
		set theDelimiter to return
		set AppleScript's text item delimiters to theDelimiter
		
		set theStatusPanel to load panel "StatusPanel" from nib "StatusPanel"
		display panel theStatusPanel attached to window "MainWindow"
		
		repeat with i from 1 to (the number of text items in theData)
			set theLine to text item i of theData
			--set chars to every character of theLine
			
			set ignoreLine to false as boolean
			set theFilename to ""
			
			if theLine starts with ";" then
				set ignoreLine to true --ignore lines starting with ";" - Trader's Little helper puts this in for some reason
				
			else if theLine contains ": " then --it's filename: fingerprint with space after the colon
				set AppleScript's text item delimiters to ": "
				set theFilename to the first text item of theLine
				set theFingerprint to the last text item of theLine
				--else if (item 1 of chars) is equal to ";" then
				--	set ignoreLine to true
			else if theLine contains ":" then --it's filename:fingerprint with no space after the colon
				set AppleScript's text item delimiters to ":"
				set theFilename to the first text item of theLine
				set theFingerprint to the last text item of theLine
			else
				set ignoreLine to true
			end if
			
			if ignoreLine is equal to false then
				tell theStatusPanel
					tell progress indicator "progressbar"
						set uses threaded animation to true
						set indeterminate to true
						start
					end tell
					set statusMessage to "Checking Fingerprint...  " & theFilename
					set contents of text field "statusMessage" to statusMessage
					call method "display" of text field "statusMessage"
				end tell
				
				
				--if the filename has a space or other character, we need to deal with that
				set theFilenameConverted to unix_path(theFilename)
				
				--display dialog theFilenameConverted
				--display dialog theFilename
				--set theResult to ""
				try
					set theCommand to get_Shell_Dir(getQuotedForm(fileDir)) & "metaflac --show-md5sum " & getQuotedForm(theFilenameConverted) & " 2>&1"
					--set theCommand to get_Shell_Dir(fileDir) & "metaflac --show-md5sum " & theFilename & " 2>&1"
					
					set theResult to do shell script theCommand
					
					if theFilename is not equal to "" and theResult is equal to theFingerprint then
						--set theResults to theResults & theFilename & ": OK"
						set theResults to theResults & verifyFlac(fileDir & theFilename) & return
						
					else if theFilename is not equal to "" and theResult is not equal to theFingerprint then
						set theResults to theResults & theFilename & ": did not match fingerprint file" & return & return
					end if
				on error errorStr
					set theResults to theResults & theFilename & ": Error reading checksum.  file may be missing or corrupt"
					set theResults to theResults & return & errorStr & return & return
				end try
				
			end if
			
			set AppleScript's text item delimiters to theDelimiter
		end repeat
	end repeat
	
	tell progress indicator "progressbar" of window "StatusPanel" to stop
	close panel window "StatusPanel"
	
	makeMessageWindow(theResults)
	
	set contents of text view "checksumList" of scroll view "checksumList" of view of tab view item "checksumTab" of tab view "tabs" of window "mainWindow" to ""
	set fingerprintcheckflag to false
	set fingerprintPaths to {} as list
	
	bounceDock()
	
	
end handleCheckFingerprint

on handleFingerprintClick()
	set dialogText to "FLAC Checksum Options"
	set dialogMessage to "Do you want me to verify the internal checksums, create a FLAC fingerprint file, or create an md5?"
	set dialogType to critical
	set defaultButtonTitle to "Verify"
	set alternateButtonTitle to "Fingerprint"
	set otherButtonTitle to "md5"
	
	set theReply to display alert dialogText as dialogType message dialogMessage default button defaultButtonTitle alternate button alternateButtonTitle other button otherButtonTitle
	
	if button returned of theReply is equal to "Verify" then
		handleFlacVerify()
	else if button returned of theReply is equal to "Fingerprint" then --make fingerprint
		handleFingerprint()
	else if button returned of theReply is equal to "md5" then
		--make  md5.  ask which kind.  regular or shntool?
		
		set dialogText to "FLAC MD5 Options"
		set dialogMessage to "Do you want create a standard md5 or a shntool md5? (if you don't know what a shntool md5 is, choose \"standard\")"
		set dialogType to critical
		set defaultButtonTitle to "Shntool"
		set alternateButtonTitle to "Standard"
		
		
		set theMD5Reply to display alert dialogText as dialogType message dialogMessage default button defaultButtonTitle alternate button alternateButtonTitle
		
		
		if button returned of theMD5Reply is equal to "Standard" then
			set MD5Paths to fingerprintPaths
			set fingerprintPaths to {}
			handleMD5Click("md5sum.md5")
		else
			set MD5Paths to fingerprintPaths
			set fingerprintPaths to {}
			handleShntoolMd5Click("shntoolmd5sum.st5")
		end if
		
		
	end if
	
	bounceDock()
	
end handleFingerprintClick

on handleFlacVerify()
	set theResults to ""
	set errorFlag to false as boolean
	
	set theStatusPanel to load panel "StatusPanel" from nib "StatusPanel"
	display panel theStatusPanel attached to window "MainWindow"
	repeat with i in fingerprintPaths
		set iPath to (i as Unicode text)
		
		tell theStatusPanel
			tell progress indicator "progressbar"
				set uses threaded animation to true
				set indeterminate to true
				start
			end tell
			set AppleScript's text item delimiters to "/"
			set statusMessage to "Verifying...  " & the last text item of iPath
			set contents of text field "statusMessage" to statusMessage
			call method "display" of text field "statusMessage"
		end tell
		
		
		
		try
			set theResults to theResults & verifyFlac(iPath) & return
			
		on error errorStr number errorNum
			
			if errorStr contains "% complete" then
				set theResults to parseFLACVerify(errorStr)
				
			else
				set theResults to theResults & errorStr & return
			end if
		end try
	end repeat
	
	tell progress indicator "progressbar" of window "StatusPanel" to stop
	close panel window "StatusPanel"
	
	if errorFlag is equal to true then
		set theResults to "One or more errors were encountered.  See below." & return & return & theResults
	end if
	makeMessageWindow(theResults)
	
	set contents of text view "checksumList" of scroll view "checksumList" of view of tab view item "checksumTab" of tab view "tabs" of window "mainWindow" to ""
	set fingerprintPaths to {} as list
	set theFingerprints to {} as list
	
	set MD5Paths to {} as list
	
	bounceDock()
	
end handleFlacVerify

on handleWavpackVerify()
	set theResults to ""
	set errorFlag to false as boolean
	
	set theStatusPanel to load panel "StatusPanel" from nib "StatusPanel"
	display panel theStatusPanel attached to window "MainWindow"
	repeat with i in wavpackPaths
		set iPath to (i as Unicode text)
		
		tell theStatusPanel
			tell progress indicator "progressbar"
				set uses threaded animation to true
				set indeterminate to true
				start
			end tell
			set AppleScript's text item delimiters to "/"
			set statusMessage to "Verifying...  " & the last text item of iPath
			set contents of text field "statusMessage" to statusMessage
			call method "display" of text field "statusMessage"
		end tell
		
		try
			set theResults to theResults & verifyWavpack(iPath) & return
			
		on error errorStr number errorNum
			
			if errorStr contains "% done" then
				set theResults to parseWavpackVerify(errorStr)
			else
				set theResults to theResults & errorStr & return
			end if
		end try
	end repeat
	
	tell progress indicator "progressbar" of window "StatusPanel" to stop
	close panel window "StatusPanel"
	
	if errorFlag is equal to true then
		set theResults to "One or more errors were encountered.  See below." & return & return & theResults
	end if
	makeMessageWindow(theResults)
	
	set contents of text view "checksumList" of scroll view "checksumList" of view of tab view item "checksumTab" of tab view "tabs" of window "mainWindow" to ""
	set wavpackPaths to {} as list
	set wavpackPaths to {} as list
	
	bounceDock()
	
	
end handleWavpackVerify

on handleAPEVerify()
	set theResults to ""
	set errorFlag to false as boolean
	
	set theStatusPanel to load panel "StatusPanel" from nib "StatusPanel"
	display panel theStatusPanel attached to window "MainWindow"
	repeat with i in APEPaths
		set iPath to (i as Unicode text)
		
		tell theStatusPanel
			tell progress indicator "progressbar"
				set uses threaded animation to true
				set indeterminate to true
				start
			end tell
			set AppleScript's text item delimiters to "/"
			set statusMessage to "Verifying...  " & the last text item of iPath
			set contents of text field "statusMessage" to statusMessage
			call method "display" of text field "statusMessage"
		end tell
		
		
		
		--		try
		set theResults to theResults & verifyAPE(iPath) & return
		
		--		on error errorStr number errorNum
		--			
		--			if errorStr contains "Progress:" then
		--				set theResults to parseAPEVerify(errorStr)
		--			else
		--				set theResults to theResults & errorStr & ": " & getMACError(errorStr) & return
		--			end if
		--		end try
	end repeat
	
	tell progress indicator "progressbar" of window "StatusPanel" to stop
	--display dialog "should be closing statuspanel now"
	
	close panel window "StatusPanel"
	
	--if errorFlag is equal to true then
	if theResults contains "Error:" then
		set theResults to "One or more errors were encountered.  See below." & return & return & theResults
	end if
	makeMessageWindow(theResults)
	
	set contents of text view "checksumList" of scroll view "checksumList" of view of tab view item "checksumTab" of tab view "tabs" of window "mainWindow" to ""
	set APEPaths to {} as list
	
	bounceDock()
	
	
end handleAPEVerify


on handleFingerprint()
	set theFingerprintFile to choose file name with prompt "Save fingerprint as..." default name "fingerprint.ffp.txt"
	
	set theStatusPanel to load panel "StatusPanel" from nib "StatusPanel"
	display panel theStatusPanel attached to window "MainWindow"
	repeat with i in fingerprintPaths
		set iPath to (i as Unicode text)
		
		tell theStatusPanel
			tell progress indicator "progressbar"
				set uses threaded animation to true
				set indeterminate to true
				start
			end tell
			set AppleScript's text item delimiters to "/"
			set statusMessage to "Fingerprinting...  " & the last text item of iPath
			set contents of text field "statusMessage" to statusMessage
			call method "display" of text field "statusMessage"
		end tell
		
		
		
		fingerprint(iPath)
		
	end repeat
	
	tell progress indicator "progressbar" of window "StatusPanel" to stop
	close panel window "StatusPanel"
	
	open for access theFingerprintFile with write permission
	
	repeat with i in theFingerprints
		set fp to (i as string)
		write fp & return to theFingerprintFile
	end repeat
	
	close access theFingerprintFile
	
	set contents of text view "checksumList" of scroll view "checksumList" of view of tab view item "checksumTab" of tab view "tabs" of window "mainWindow" to ""
	set fingerprintPaths to {} as list
	set theFingerprints to {} as list
	
	bounceDock()
	
	
end handleFingerprint

on handleMD5Click(defaultName)
	set theMD5File to choose file name with prompt "Save md5 checksum as..." default name defaultName
	set theMD5File to (POSIX path of theMD5File)
	set theMD5File to unix_path(theMD5File)
	
	set theFiles to ""
	set filePath to the first item of MD5Paths as Unicode text
	
	
	set AppleScript's text item delimiters to "/"
	repeat with i in MD5Paths
		set fileName to the last text item of i
		set theFiles to theFiles & space & getQuotedForm(fileName)
	end repeat
	
	--need to grab the directory path only from filePath
	set fileDir to get_Directory(filePath)
	
	
	set theStatusPanel to load panel "StatusPanel" from nib "StatusPanel"
	display panel theStatusPanel attached to window "MainWindow"
	
	tell theStatusPanel
		tell progress indicator "progressbar"
			set uses threaded animation to true
			set indeterminate to true
			start
		end tell
		set statusMessage to "making md5...  "
		set contents of text field "statusMessage" to statusMessage
		call method "display" of text field "statusMessage"
	end tell
	
	
	do shell script get_Shell_Dir(getQuotedForm(fileDir)) & "md5sum -b " & theFiles & " > " & getQuotedForm(theMD5File)
	
	tell progress indicator "progressbar" of window "StatusPanel" to stop
	close panel window "StatusPanel"
	
	set contents of text view "checksumList" of scroll view "checksumList" of view of tab view item "checksumTab" of tab view "tabs" of window "mainWindow" to ""
	set MD5Paths to {} as list
	
	bounceDock()
	
	
end handleMD5Click

on handleShntoolMd5Click(defaultName)
	set theMD5File to choose file name with prompt "Save shntool md5 checksum as..." default name defaultName
	set theMD5File to (POSIX path of theMD5File)
	set theMD5File to unix_path(theMD5File)
	
	set theFiles to ""
	set filePath to the first item of MD5Paths as Unicode text
	
	set AppleScript's text item delimiters to "/"
	repeat with i in MD5Paths
		set fileName to the last text item of i
		set theFiles to theFiles & space & getQuotedForm(fileName)
	end repeat
	
	
	--need to grab the directory path only from filePath
	set fileDir to get_Directory(filePath)
	
	
	set theStatusPanel to load panel "StatusPanel" from nib "StatusPanel"
	display panel theStatusPanel attached to window "MainWindow"
	
	tell theStatusPanel
		tell progress indicator "progressbar"
			set uses threaded animation to true
			set indeterminate to true
			start
		end tell
		set statusMessage to "making shntool md5...  "
		set contents of text field "statusMessage" to statusMessage
		call method "display" of text field "statusMessage"
	end tell
	
	
	
	--do shell script get_Shell_Dir(getQuotedForm(fileDir)) & "md5sum -b " & theFiles & " > " & getQuotedForm(theMD5File)
	do shell script get_Shell_Dir(getQuotedForm(fileDir)) & "shntool hash -m" & theFiles & " > " & getQuotedForm(theMD5File)
	
	tell progress indicator "progressbar" of window "StatusPanel" to stop
	close panel window "StatusPanel"
	
	set contents of text view "checksumList" of scroll view "checksumList" of view of tab view item "checksumTab" of tab view "tabs" of window "mainWindow" to ""
	set MD5Paths to {} as list
	
	bounceDock()
	
end handleShntoolMd5Click

on handleSHNtoolClick()
	
	set errorLog to ""
	set command to ""
	set theColumn to the current column of matrix "shntoolCmd" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow"
	set theRow to the current row of matrix "shntoolCmd" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow"
	if theRow is equal to 1 then
		if theColumn is equal to 1 then
			set command to "shntool len"
		else if theColumn is equal to 2 then
			set command to "shntool info"
		else if theColumn is equal to 3 then
			set command to "shntool join"
		else if theColumn is equal to 4 then
			set command to "shntool split"
		else if theColumn is equal to 5 then
			set command to "shntool cmp"
		else if theColumn is equal to 6 then
			set command to "shntool cue"
		end if
	else if theRow is equal to 2 then
		if theColumn is equal to 6 then
			set command to "shntool trim"
		end if
	end if
	
	set theFiles to ""
	set lenResult to ""
	set theOutput to ""
	set shnlenOptions to the current row of matrix "shnlenOptions" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow"
	
	set filePath to the first item of SHNtoolPaths as Unicode text
	
	set AppleScript's text item delimiters to "/"
	repeat with i in SHNtoolPaths
		--		set fileName to the last text item of i
		--		set theFiles to theFiles & space & fileName
		set theFiles to theFiles & space & getQuotedForm(i)
	end repeat
	
	--need to grab the directory path only from filePath
	--	set fileDir to get_Directory(filePath)
	
	
	--if splitting len info by disc-----------------
	if command is equal to "shntool len" and shnlenOptions is equal to 3 then
		try
			set discList to {} as list
			
			repeat with i in SHNtoolPaths
				set iPath to (i as Unicode text)
				set AppleScript's text item delimiters to "/"
				set iPath to the last text item of iPath
				set AppleScript's text item delimiters to "d"
				--get the number after the "d" for which disc.  filenames must be foobar2003-10-31d1t01 format
				set afterDisc to the last text item of iPath
				set chars to every character of afterDisc
				set discNumber to (item 1 of chars as number)
				
				--if format is d01t01, then skip the zero and get the number
				if discNumber is equal to 0 then
					set discNumber to (item 2 of chars as number)
				end if
				
				--bug here in that if we give a d2 with no d1, it'll put the first track in d2
				--(because discNumber is greater than the length of discList), but then when track 2 comes,
				--it is also greater than the length of discList, so it puts that in d2.  so all are in d2
				--except for track 1, which is in d1.
				--possible solution?: if the length of disclist is zero and discNumber is greater than 1, create an
				--empty disc for d1 (up to discNumber -1)?
				if (the length of discList) is equal to 0 and discNumber is greater than 1 then
					repeat with i from 1 to (discNumber - 1)
						set theTracks to ""
						--set theTracks to theTracks & space & iPath
						set discList to discList & theTracks
					end repeat
				end if
				
				if discNumber is greater than the length of discList then
					set theTracks to ""
					--set theTracks to theTracks & space & iPath
					set theTracks to theTracks & space & getQuotedForm((i as Unicode text))
					set discList to discList & theTracks
				else --there's already a track associated with this disc
					--set theTracks to ""
					set theTracks to item discNumber of discList as Unicode text
					--		set theTracks to theTracks & space & iPath
					set theTracks to theTracks & space & getQuotedForm((i as Unicode text))
					set item discNumber of discList to theTracks
				end if
				--------------------------------------
			end repeat
			set discNum to 0
			set lenByDiscResults to {} as list
			set discNumbers to {} as list
			repeat with i in discList
				set currentDisc to (i as Unicode text) --currentdisc = list of tracks for this disc
				set discNum to discNum + 1
				--			set lenByDiscResults to lenByDiscResults & (do shell script get_Shell_Dir(fileDir) & command & space & currentDisc)
				if currentDisc is not equal to "" then
					set lenByDiscResults to lenByDiscResults & (do shell script shellPath & command & space & currentDisc)
					set discNumbers to discNumbers & discNum
				end if
			end repeat
			set lenResult to writeShnLenByDisc(lenByDiscResults, discNumbers)
			makeMessageWindow(lenResult)
		on error errorStr number errorNum
			set errorMessage to errorStr & return & "Make sure the files are named properly for len by disc."
			display dialog errorMessage buttons {"OK"} default button "OK" with icon 0 giving up after 20
			
		end try
		
	else if command is equal to "shntool join" then
		set outputDir to choose folder
		set outputDir to (POSIX path of outputDir)
		set outputDir to unix_path(outputDir)
		
		set outputFormat to ""
		if the current column of matrix "joinSplitFormat" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
			set outputFormat to "shn"
		else if the current column of matrix "joinSplitFormat" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" is equal to 2 then
			set outputFormat to "flac"
		else if the current column of matrix "joinSplitFormat" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" is equal to 3 then
			set outputFormat to "wav"
		else if the current column of matrix "joinSplitFormat" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" is equal to 4 then
			set outputFormat to "aiff"
		end if
		
		set theStatusPanel to load panel "StatusPanel" from nib "StatusPanel"
		display panel theStatusPanel attached to window "MainWindow"
		tell theStatusPanel
			tell progress indicator "progressbar"
				set uses threaded animation to true
				set indeterminate to true
				start
			end tell
			set statusMessage to "Joining... "
			set contents of text field "statusMessage" to statusMessage
			call method "display" of text field "statusMessage"
		end tell
		
		
		--end old status panel code
		
		try
			do shell script shellPath & command & space & "-o " & outputFormat & " -P none -n -d " & getQuotedForm(outputDir) & space & theFiles
			
		on error errorStr number errorNum
			display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to errorLog & return & ": " & errorStr & return
		end try
		tell progress indicator "progressbar" of window "StatusPanel" to stop
		
		close panel window "StatusPanel"
		if errorLog is not equal to "" then
			makeMessageWindow(errorLog)
		end if
		set errorLog to ""
		
		
	else if command is equal to "shntool split" then
		
		tell open panel
			set title to "Choose file with split point data"
			set prompt to "OK"
			set treat packages as directories to true
			set can choose directories to false
			set can choose files to true
			set allows multiple selection to false
		end tell
		set theResult to display open panel
		
		if theResult is 1 then
			-- For some unknown (as of yet) you must coerce the 'path names' to a list (even though it is defined as list).
			set the pathNames to (path names of open panel as list)
			set splitFile to the first item of pathNames
			set splitFile to unix_path(splitFile)
			
			set outputDir to choose folder with prompt "Choose Output Folder"
			set outputDir to (POSIX path of outputDir)
			set outputDir to unix_path(outputDir)
			
			set outputFormat to ""
			if the current column of matrix "joinSplitFormat" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
				set outputFormat to "shn"
			else if the current column of matrix "joinSplitFormat" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" is equal to 2 then
				set outputFormat to "flac"
			else if the current column of matrix "joinSplitFormat" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" is equal to 3 then
				set outputFormat to "wav"
			else if the current column of matrix "joinSplitFormat" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" is equal to 4 then
				set outputFormat to "aiff"
			end if
			
			set theStatusPanel to load panel "StatusPanel" from nib "StatusPanel"
			display panel theStatusPanel attached to window "MainWindow"
			tell theStatusPanel
				tell progress indicator "progressbar"
					set uses threaded animation to true
					set indeterminate to true
					start
				end tell
				set statusMessage to "Splitting... "
				set contents of text field "statusMessage" to statusMessage
				call method "display" of text field "statusMessage"
			end tell
			
			
			
			try
				do shell script shellPath & command & space & "-f " & getQuotedForm(splitFile) & " -P none -o " & outputFormat & " -d " & getQuotedForm(outputDir) & space & getQuotedForm(item 1 of SHNtoolPaths)
			on error errorStr number errorNum
				display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
				set errorLog to errorLog & return & errorStr & return
			end try
			
			tell progress indicator "progressbar" of window "StatusPanel" to stop
			close panel window "StatusPanel"
		end if
		
		if errorLog is not equal to "" then
			makeMessageWindow(errorLog)
		end if
		set errorLog to ""
		
		
	else if command is equal to "shntool cmp" then
		set file1 to item 1 of SHNtoolPaths
		set file2 to item 2 of SHNtoolPaths
		
		set theStatusPanel to load panel "StatusPanel" from nib "StatusPanel"
		display panel theStatusPanel attached to window "MainWindow"
		tell theStatusPanel
			tell progress indicator "progressbar"
				set uses threaded animation to true
				set indeterminate to true
				start
			end tell
			set statusMessage to "Comparing... "
			set contents of text field "statusMessage" to statusMessage
			call method "display" of text field "statusMessage"
		end tell
		
		
		try
			set lenResult to do shell script shellPath & command & space & " -P dot " & getQuotedForm(file1) & space & getQuotedForm(file2) & " 2>&1"
			
		on error errorStr number errorNum
			display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to errorStr
		end try
		
		tell progress indicator "progressbar" of window "StatusPanel" to stop
		close panel window "StatusPanel"
		
		makeMessageWindow(errorLog & return & return & lenResult)
		set errorLog to ""
		
	else if command is equal to "shntool cue" then
		set theCueSheet to choose file name with prompt "Save CUE sheet as" default name "cuesheet.cue"
		
		set outputPath to (POSIX path of theCueSheet)
		set outputPath to unix_path(outputPath)
		
		try
			set theResult to do shell script shellPath & command & space & "-P none -c " & theFiles & " > " & getQuotedForm(outputPath)
		on error errorStr number errorNum
			display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to errorStr
		end try
		
		if errorLog is not equal to "" then
			makeMessageWindow(errorLog & return & return & theResult)
		end if
		set errorLog to ""
	else if command is equal to "shntool trim" then
		
		set outputDir to choose folder with prompt "Choose Output Folder"
		set outputDir to (POSIX path of outputDir)
		set outputDir to unix_path(outputDir)
		
		set outputFormat to ""
		if the current column of matrix "joinSplitFormat" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
			set outputFormat to "shn"
		else if the current column of matrix "joinSplitFormat" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" is equal to 2 then
			set outputFormat to "flac"
		else if the current column of matrix "joinSplitFormat" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" is equal to 3 then
			set outputFormat to "wav"
		else if the current column of matrix "joinSplitFormat" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" is equal to 4 then
			set outputFormat to "aiff"
		end if
		
		
		
		set theStatusPanel to load panel "StatusPanel" from nib "StatusPanel"
		display panel theStatusPanel attached to window "MainWindow"
		tell theStatusPanel
			tell progress indicator "progressbar"
				set uses threaded animation to true
				set indeterminate to true
				start
			end tell
			set statusMessage to "Trimming... "
			set contents of text field "statusMessage" to statusMessage
			call method "display" of text field "statusMessage"
		end tell
		
		set theResult to ""
		try
			set theResult to do shell script shellPath & command & space & "-d " & getQuotedForm(outputDir) & " -o " & outputFormat & " -O never -P none" & theFiles & " 2>&1"
		on error errorStr number errorNum
			display dialog "Error" buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to errorStr
		end try
		
		tell progress indicator "progressbar" of window "StatusPanel" to stop
		close panel window "StatusPanel"
		
		
		if errorLog is not equal to "" or theResult is not equal to "" then
			makeMessageWindow(errorLog & return & return & theResult)
		end if
		set errorLog to ""
		
	else --regular shntool len or info
		
		--set lenResult to do shell script get_Shell_Dir(fileDir) & command & space & theFiles
		
		set lenResult to do shell script shellPath & command & space & theFiles
		
		--if len then remove path from filenames
		if command is equal to "shntool len" then
			--if parsed len times only
			if shnlenOptions is equal to 2 then
				
				set lenResult to writeShnLenParsed(lenResult)
				
				---trackname code------------------------------------------------------------------------------------
				--display dialog (number of items of trackNames)
				--do we have tracknames to go with these times?
				--if (number of items of trackNames) is greater than 0 then
				--				if trackNames is not equal to {} then
				--					set newOutput to ""
				--					set AppleScript's text item delimiters to return
				--					display dialog (number of text items of lenResult)
				--					repeat with i from 1 to ((number of text items of lenResult) - 1)
				--						set newOutput to newOutput & (item i of trackNames) & space & (text item i of lenResult) & return
				--					end repeat
				--					set lenResult to newOutput
				--				end if
				------------------------------------------------------------
				
			else --just normal shnlen
				
				set AppleScript's text item delimiters to return
				--skip first line, which is column headers
				set theOutput to the first text item in lenResult & return
				
				set numOfLines to number of text items in lenResult
				repeat with j from 2 to (numOfLines - 1)
					set theLine to text item j of lenResult
					set theLine to removePath(theLine)
					set theOutput to theOutput & theLine & return
					set AppleScript's text item delimiters to return
					
				end repeat
				
				set theOutput to theOutput & the last text item in lenResult
				set lenResult to theOutput
			end if
		end if --command is equal to shnlen
		
		makeMessageWindow(lenResult)
	end if
	
	
	set contents of text view "shntoolList" of scroll view "shntoolList" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to ""
	set the current row of matrix "shnlenOptions" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to 0
	set SHNtoolPaths to {}
	
	bounceDock()
	
	
end handleSHNtoolClick

on handleEncodeClick()
	setEncodingIcon()
	
	set sameOutputDirectory to the state of button "sourceEncode" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow"
	
	if sameOutputDirectory is 0 then
		set outputPath to choose folder
		set outputPath to (POSIX path of outputPath)
		set outputPath to unix_path(outputPath)
	else
		set outputPath to null
	end if
	
	set theStatusPanel to load panel "StatusPanel" from nib "StatusPanel"
	display panel theStatusPanel attached to window "MainWindow"
	repeat with i in encodePaths
		set iPath to (i as Unicode text)
		set AppleScript's text item delimiters to "/"
		set fileName to the last text item of iPath
		tell theStatusPanel
			tell progress indicator "progressbar"
				set uses threaded animation to true
				set indeterminate to true
				start
			end tell
			set statusMessage to "Encoding...  " & fileName
			
			set contents of text field "statusMessage" to statusMessage
			call method "display" of text field "statusMessage"
		end tell
		
		compress(iPath, outputPath)
		
	end repeat
	
	tell progress indicator "progressbar" of window "StatusPanel" to stop
	set contents of text field "statusMessage" of window "StatusPanel" to ""
	close panel window "StatusPanel"
	
	set contents of text view "encodeList" of scroll view "encodeList" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to ""
	
	
	set md5 to the state of button "generateMD5" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow"
	
	if md5 is equal to 1 then
		
		
		
		handleMD5Click("md5sum.md5")
		
		set contents of text view "checksumList" of scroll view "checksumList" of view of tab view item "checksumTab" of tab view "tabs" of window "mainWindow" to ""
		--set encodePaths to {} as list
		
		set MD5Paths to {} as list
	end if
	
	set deleteEncode to the state of button "deleteEncode" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow"
	
	
	if errorLog is not equal to "" then
		makeMessageWindow(errorLog)
	else --no error
		if deleteEncode is 1 then
			repeat with i in encodePaths
				set iPath to (i as Unicode text)
				set deunixpath to de_unix_path(iPath)
				set macPath to POSIX file deunixpath
				tell application "Finder"
					delete macPath
				end tell
				--do shell script "mv " & iPath & " ~/.Trash/"
			end repeat
		end if
	end if
	
	set encodePaths to {} as list
	set MD5Paths to {} as list
	set errorLog to ""
	set errorFlag to false
	
	setNormalIcon()
	bounceDock()
	
end handleEncodeClick

on handleDecodeClick()
	setDecodingIcon()
	set errorLog to ""
	
	set sameOutputDirectory to the state of button "sourceDecode" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow"
	
	if sameOutputDirectory is 0 then
		set outputPath to choose folder
		set outputPath to (POSIX path of outputPath)
		set outputPath to unix_path(outputPath)
	else
		set outputPath to null
	end if
	
	
	
	set theStatusPanel to load panel "StatusPanel" from nib "StatusPanel"
	display panel theStatusPanel attached to window "MainWindow"
	repeat with i in decodePaths
		set iPath to (i as Unicode text)
		
		tell theStatusPanel
			tell progress indicator "progressbar"
				set uses threaded animation to true
				set indeterminate to true
				start
			end tell
			set AppleScript's text item delimiters to "/"
			set statusMessage to "Decoding...  " & the last text item of iPath
			set contents of text field "statusMessage" to statusMessage
			call method "display" of text field "statusMessage"
		end tell
		
		
		
		my decompress(iPath, outputPath)
		
		
	end repeat
	
	tell progress indicator "progressbar" of window "StatusPanel" to stop
	close panel window "StatusPanel"
	
	set deleteDecode to the state of button "deleteDecode" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow"
	
	if errorLog is not equal to "" then
		makeMessageWindow(errorLog)
	else --no error
		if deleteDecode is 1 then
			repeat with i in decodePaths
				set iPath to (i as Unicode text)
				set deunixpath to de_unix_path(iPath)
				set macPath to POSIX file deunixpath
				tell application "Finder"
					delete macPath
				end tell
				--do shell script "mv " & iPath & " ~/.Trash/"
			end repeat
		end if
	end if
	
	set contents of text view "decodeList" of scroll view "decodeList" of view of tab view item "decodeTab" of tab view "tabs" of window "mainWindow" to ""
	set decodePaths to {} as list
	set errorLog to ""
	
	setNormalIcon()
	bounceDock()
	
end handleDecodeClick

on handleFixClick()
	setFixingIcon()
	
	--this one ain't pretty
	
	set outputPath to choose folder
	set outputPath to (POSIX path of outputPath)
	set outputPath to unix_path(outputPath)
	
	
	set fileNames to ""
	set theResult to ""
	
	--going to create a list of md5 files, one md5 file for each disc
	set md5List to {} as list
	
	set theFiles to ""
	set theSHNs to {} as list
	
	repeat with i in fixPaths
		set iPath to (i as Unicode text)
		set theFiles to theFiles & space & getQuotedForm(iPath)
	end repeat
	
	set outputFormat to ""
	if the current column of matrix "fixFormat" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
		set outputFormat to "shn"
	else if the current column of matrix "fixFormat" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" is equal to 2 then
		set outputFormat to "flac"
	else if the current column of matrix "fixFormat" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" is equal to 3 then
		set outputFormat to "wav"
	else if the current column of matrix "fixFormat" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" is equal to 4 then
		set outputFormat to "aiff"
	end if
	
	set theStatusPanel to load panel "StatusPanel" from nib "StatusPanel"
	display panel theStatusPanel attached to window "MainWindow"
	
	tell theStatusPanel
		tell progress indicator "progressbar"
			set uses threaded animation to true
			set indeterminate to true
			start
		end tell
		set statusMessage to "Fixing...  "
		set contents of text field "statusMessage" to statusMessage
		call method "display" of text field "statusMessage"
	end tell
	
	
	
	--	set theCommand to shellPath & "shnfix -o " & outputFormat & space & "-d " & outputPath & space & theFiles
	
	--set theCommand to shellPath & "shnfix -o " & outputFormat & space & "-d " & outputPath & space & theFiles & " >& " & outputPath & "/" & "progress.txt &"
	
	if outputFormat is equal to "flac" then
		set flacLevel to the contents of slider "fixFlacSlider" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" as integer
		
		set theCommand to shellPath & "shntool fix -P none -O never -o 'cust ext=flac flac -s -" & flacLevel & " -o %f - '" & space & "-d " & getQuotedForm(outputPath) & space & theFiles & " 2>&1"
		
	else
		set theCommand to shellPath & "shntool fix -P none -O never -o " & outputFormat & space & "-d " & getQuotedForm(outputPath) & space & theFiles & " 2>&1"
	end if
	set success to false as boolean
	try
		set theResult to do shell script theCommand
		set theSHNs to getFixedFileNames(theResult)
		--displayProgress(outputPath)
		tell progress indicator "progressbar" of window "StatusPanel" to stop
		close panel window "StatusPanel"
		set success to true
		makeMessageWindow(theResult)
	on error errorStr number errorNum
		tell progress indicator "progressbar" of window "StatusPanel" to stop
		close panel window "StatusPanel"
		--	display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
		
		if errorStr contains "everything seems fine" then
			set AppleScript's text item delimiters to return
			display dialog (text item 2 of errorStr) buttons {"OK"} default button "OK" with icon 0 giving up after 20
			
		else
			
			display dialog "SHNtool encountered an error.  Please check the output window for more information" buttons {"OK"} default button "OK" with icon 0 giving up after 20
		end if
		makeMessageWindow(errorStr)
	end try
	
	
	--now compute md5 for all files if no errors in fixing
	
	if success is equal to true then
		
		if the current row of matrix "fixMD5Option" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" is equal to 2 then
			set MD5Paths to theSHNs
			my handleMD5Click("md5sum.md5")
			set MD5Paths to {} as list
			
		else if the current row of matrix "fixMD5Option" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" is equal to 3 then
			set md5List to md5ByDisc(theSHNs)
			
			set discNum to 0
			repeat with i in md5List
				set currentMD5 to (i as list) --currentMD5 = list of shns for this disc's md5
				set MD5Paths to currentMD5
				set discNum to discNum + 1
				my handleMD5Click("disc" & discNum & ".md5")
			end repeat
			
			set MD5Paths to {} as list
			
		end if
		
		--only delete originals if successful fixing
		set deleteFix to the state of button "deleteFix" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow"
		if deleteFix is 1 then
			repeat with i in fixPaths
				set iPath to (i as Unicode text)
				set deunixpath to de_unix_path(iPath)
				set macPath to POSIX file deunixpath
				tell application "Finder"
					delete macPath
				end tell
				--do shell script "mv " & iPath & " ~/.Trash/"
			end repeat
		end if
		
	end if
	
	set contents of text view "fixList" of scroll view "fixList" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" to ""
	set fixPaths to {} as list
	setNormalIcon()
	bounceDock()
	
	
end handleFixClick

--method to display info for selected file, OR if more than 1 file selected, show nothing, but disable certain fields
on handleFlacTags()
	set selectedRows to {} as list
	set theObject to table view "flacFiles" of scroll view "flacFiles" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow"
	set theDataSource to data source of theObject
	
	set selectedRows to selected rows of theObject
	
	--repeat with theRow in selectedRows
	if the length of selectedRows is 1 then
		--set the nameTag to enabled
		set enabled of text field "nameTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to true
		set enabled of text field "trackNumberTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to true
		
		
		set theRow to item 1 of selectedRows
		set selectedName to contents of data cell "flacFiles" of data row theRow of theDataSource
		set theFile to item theRow of tagPaths
		
		--set debugString to debugString & return & "you selected: " & selectedName & return
		--makeMessageWindow(debugString)
		
		set AppleScript's text item delimiters to "/"
		set fileName to the last text item of theFile
		set string value of text field "currentFile" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to fileName
		showTags(theFile)
		
	else --multiple selections.  we want to show empty tags (even if info there) and disable/hide the name field
		--first empty the tags
		clearFlacTags()
		
		--then disable the name one
		set enabled of text field "nameTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to false
		set enabled of text field "trackNumberTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to false
		
		set string value of text field "currentFile" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to "multiple selections"
		
	end if
	--end repeat
	bounceDock()
	
end handleFlacTags

on handleFlacTagsButton()
	set selectedRows to {} as list
	set errorLog to ""
	
	set theObject to table view "flacFiles" of scroll view "flacFiles" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow"
	set theDataSource to data source of theObject
	
	set selectedRows to selected rows of theObject
	
	if the length of selectedRows is 1 then
		set theRow to item 1 of selectedRows
		--set theFile to contents of data cell "flacFiles" of data row theRow of theDataSource
		set theFile to item theRow of tagPaths
		changeTags(theFile, false)
	else --more than 1 selected, we can edit everything but the title, track number
		
		set autoName to the state of button "flacTagAutoName" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow"
		
		repeat with theRow in selectedRows
			--set theRow to item i of selectedRows
			--set theFile to contents of data cell "flacFiles" of data row theRow of theDataSource
			set theFile to item theRow of tagPaths
			changeTags(theFile, true)
			
			
			if autoName is equal to 1 then
				try
					set trackName to (item theRow of trackNames) as Unicode text
					set theDelimiter to "
"
					set AppleScript's text item delimiters to theDelimiter
					writeTags(theFile, "TITLE", text item 1 of trackName)
					writeTags(theFile, "TRACKNUMBER", theRow)
				on error errorStr number errorNum
					display dialog ("error writing tags for: " & theFile) buttons {"OK"} default button "OK" with icon 0 giving up after 20
					set errorLog to errorLog & theFile & ": " & errorStr & return
				end try
			end if
		end repeat
	end if
	
	if errorLog is not equal to "" then
		makeMessageWindow(errorLog)
	end if
	set errorLog to ""
	clearFlacTags()
	set string value of text field "currentFile" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to ""
	bounceDock()
	
end handleFlacTagsButton

on stripEquals(nameValuePair)
	set AppleScript's text item delimiters to "="
	return (the last text item of nameValuePair)
end stripEquals

--helper methods---------------------------------------------------------------------------
on ASCII_Sort(my_list)
	set the index_list to {}
	set the sorted_list to {}
	repeat (the length of my_list) times
		set the low_item to ""
		repeat with i from 1 to (length of my_list)
			if i is not in the index_list then
				set this_item to item i of my_list as Unicode text
				if the low_item is "" then
					set the low_item to this_item
					set the low_item_index to i
				else if this_item comes before the low_item then
					set the low_item to this_item
					set the low_item_index to i
				end if
			end if
		end repeat
		set the end of sorted_list to the low_item
		set the end of the index_list to the low_item_index
	end repeat
	return the sorted_list
end ASCII_Sort

--on unix_path(path)
--	set newPath to unix_path_2(path, false)
--	return newPath
--end unix_path

on unix_path(mac_path)
	--we want to convert to posix unless it's already posix?
	if mac_path contains ":" and mac_path does not start with "/" then
		set mac_path to (POSIX path of mac_path)
	end if
	
	--	end if
	
	--	if bool is equal to true then
	--		if mac_path contains ":" then
	--			display dialog ("getting posix path")
	--			set unixpath to (POSIX path of mac_path)
	--			--set unixpath to mac_path
	--			display dialog (unixpath)
	--		else
	set unixpath to mac_path
	--		end if
	--	else --bool is false, we want a normal path
	--		set unixpath to mac_path
	--	end if
	--every line after this
	--	set chars to every character of unixpath
	--	
	--	repeat with i from 1 to length of chars
	--		if "!$&\"'*(){[|;<>?~` \\" contains (item i of chars as Unicode text) then
	--			--if ("!$&\"'*(){[|;<>?~` \\" as Unicode text) contains (Unicode text i through i of unixpath) then
	--			set item i of chars to "\\" & (item i of chars as Unicode text)
	--		end if
	--		
	--		
	--		
	--	end repeat
	--	
	--	set AppleScript's text item delimiters to ""
	--	set thePath to every item of chars as Unicode text
	--end every line
	--display dialog quoted form of unixpath
	
	return unixpath
end unix_path

on de_unix_path(unix_path)
	--	set chars to every character of unix_path
	--	repeat with i from 1 to length of chars
	--		if "!$&\"'*(){[|;<>?~` \\" contains (item i of chars as Unicode text) and (item (i - 1) of chars as Unicode text is equal to "\\") then
	--			set item (i - 1) of chars to ""
	--		end if
	--		
	--	end repeat
	--	
	--	set AppleScript's text item delimiters to ""
	--	set thePath to every item of chars as string
	--	
	--	return thePath
	return unix_path
end de_unix_path




on makeMessageWindow(message)
	--load panel "shntoolWIndow" from nib "MainMenu"	
	load nib "shntoolWindow"
	
	
	--set windowCount to "shntoolWindow"
	set windowName to "shntoolWindow"
	set name of window "shntoolWindow" to windowName
	--return window "shntoolWindow"
	
	
	tell window "shntoolWindow"
		set contents of text view "shntoolText" of scroll view "shntoolEditor" to message
		set visible to true
	end tell
	
end makeMessageWindow

on showInputWindow()
	set windowName to "inputWindow"
	set name of window "inputWindow" to windowName
	
	tell window "inputWindow"
		--set contents of text view "inputText" of scroll view "inputEditor" to "hello"
		set visible to true
	end tell
end showInputWindow

on getTrackNameInput()
	set theInput to (contents of text view "inputText" of scroll view "inputEditor" of window "inputWindow")
	
	tell window "inputWindow"
		set visible to false
	end tell
	
	return theInput
end getTrackNameInput

on getMaxTrackNameLength()
	set max to 0
	repeat with i in trackNames
		set chars to every character of (i as Unicode text)
		if (length of chars) is greater than max then
			set max to length of chars
		end if
	end repeat
	
	return max
end getMaxTrackNameLength

on padTracknames(name, max)
	
	set chars to every character of name
	set theLength to length of chars
	
	set numSpaces to max - theLength
	
	set counter to 0
	repeat until counter = numSpaces
		set name to name & space
		set counter to counter + 1
	end repeat
	return name
end padTracknames

on get_Directory(filePath)
	set fileDir to ""
	set AppleScript's text item delimiters to "/"
	repeat with i from 1 to ((number of text items in filePath) - 1)
		set fileDir to fileDir & (text item i of filePath) & "/"
	end repeat
	return fileDir
end get_Directory

on get_fileName_no_extension(filePath)
	set fileName to ""
	set AppleScript's text item delimiters to "."
	repeat with i from 1 to ((number of text items in filePath) - 1)
		set fileName to fileName & (text item i of filePath)
		--keep all periods in filename except at the very end
		if i is not equal to ((number of text items in filePath) - 1) then
			set fileName to fileName & "."
		end if
	end repeat
	return fileName
end get_fileName_no_extension



on get_Shell_Dir(directory)
	--set shellDir to "export PATH=:/usr/local/bin:$PATH; cd " & directory & "; "
	set shellDir to "export PATH=:" & binariesPath & ":$PATH; cd " & directory & "; "
	return shellDir
end get_Shell_Dir

on handleAdd()
	------------------------------------------------
	tell open panel
		set title to "Choose files for processing"
		set prompt to "Add files"
		set treat packages as directories to true
		set can choose directories to false
		set can choose files to true
		set allows multiple selection to true
	end tell
	set theResult to display open panel
	
	if theResult is 1 then
		-- For some unknown (as of yet) you must coerce the 'path names' to a list (even though it is defined as list).
		set the pathNames to (path names of open panel as list)
		open (pathNames)
	end if
	
	----------------------------------------------------
end handleAdd

on writeShnLenByDisc(lenByDiscResults, discNumbers)
	--lenByDiscResults is a list of shnlen outputs by disc
	set returnString to ""
	
	--set lenFile to choose file name with prompt "Save len output as..." default name "lenoutput.txt"
	
	
	----trackname code--------------------------------------------------------------
	set trackNamesExist to false as boolean
	set maxTrackNameLength to 0
	if trackNames is not equal to {} then
		set trackNamesExist to true
		set maxTrackNameLength to getMaxTrackNameLength()
		set trackNameCount to 1
	end if
	----end trackname code-------------------------------------------------
	
	repeat with i from 1 to (length of lenByDiscResults)
		set output to item i of lenByDiscResults
		--write disc header
		set returnString to returnString & "Disc " & (item i of discNumbers) & return & return
		set trackNum to 1
		set AppleScript's text item delimiters to return
		
		--skip first line, which is column headers
		--find the first non space in the line, then grab between that and next space (to get time)
		set numOfLines to number of text items in output
		repeat with j from 2 to numOfLines
			set theLine to text item j of output
			--removePath(theLine)
			
			set chars to every character of theLine
			repeat with k from 1 to length of chars
				if item k of chars is equal to " " then
					set item k of chars to ""
				else --we found the first number (non-space)
					exit repeat
				end if
			end repeat
			set AppleScript's text item delimiters to ""
			set theLine to every item of chars as Unicode text
			set AppleScript's text item delimiters to " "
			set theTime to text item 1 of theLine
			--pad time with zeros so xx:xx.xx
			set AppleScript's text item delimiters to ":"
			--if x:xx.xx
			if the length of (the first text item of theTime) is equal to 1 then
				set theTime to "0" & theTime
			end if
			
			--figure out which disc number and which track it is on this disc
			--also pad a single digit track number with a leading zero
			set outputTrackNum to ""
			if trackNum is less than 10 then
				set outputTrackNum to "0" & trackNum as Unicode text
			else
				set outputTrackNum to trackNum as Unicode text
			end if
			--end which disc/track num? -------------
			if j is equal to numOfLines then
				--it's the total for disc
				set returnString to returnString & return & "Disc " & (item i of discNumbers) & " Total: " & theTime & return & return & return
			else --not total, it's a track
				if trackNamesExist then
					if trackNameCount is greater than (count of trackNames) then
						--if we gave fewer tracknames than tracks, we screwed up.  put question marks in
						set trackName to "???"
					else
						set trackName to (item trackNameCount of trackNames) as Unicode text
						set trackName to padTracknames(trackName, maxTrackNameLength)
					end if
					set returnString to returnString & outputTrackNum & space & trackName & space & theTime & return
					set trackNameCount to trackNameCount + 1
					
				else
					
					set returnString to returnString & outputTrackNum & space & theTime & return
				end if
			end if
			set AppleScript's text item delimiters to return
			set trackNum to trackNum + 1
		end repeat
	end repeat
	--open for access lenFile with write permission
	--write returnString to lenFile
	--close access lenFile
	
	if trackNamesExist then
		set trackNames to {}
	end if
	return returnString
end writeShnLenByDisc

on writeShnLenParsed(lenResults)
	
	
	------------------------------------------
	--display dialog (number of items of trackNames)
	--do we have tracknames to go with these times?
	--if (number of items of trackNames) is greater than 0 then
	--	if trackNames is not equal to {} then
	--		set newOutput to ""
	--		set AppleScript's text item delimiters to return
	--		display dialog (number of text items of lenResult)
	--		repeat with i from 1 to ((number of text items of lenResult) - 1)
	--			set newOutput to newOutput & (item i of trackNames) & space & (text item i of lenResult) & return
	--		end repeat
	--		set lenResult to newOutput
	--	end if
	
	----trackname code--------------------------------------------------------------
	set trackNamesExist to false as boolean
	set maxTrackNameLength to 0
	if trackNames is not equal to {} then
		set trackNamesExist to true
		set maxTrackNameLength to getMaxTrackNameLength()
		set trackNameCount to 1
	end if
	----end trackname code-------------------------------------------------
	
	--lenByDiscResults is a list of shnlen outputs by disc
	set returnString to ""
	
	set trackNum to 1
	set AppleScript's text item delimiters to return
	
	--skip first line, which is column headers
	--find the fist non space in the line, then grab between that and next space (to get time)
	set numOfLines to number of text items in lenResults
	repeat with j from 2 to numOfLines
		set theLine to text item j of lenResults
		--removePath(theLine)
		
		set chars to every character of theLine
		repeat with k from 1 to length of chars
			if item k of chars is equal to " " then
				set item k of chars to ""
			else --we found the first number (non-space)
				exit repeat
			end if
		end repeat
		set AppleScript's text item delimiters to ""
		set theLine to every item of chars as Unicode text
		set AppleScript's text item delimiters to " "
		set theTime to text item 1 of theLine
		--pad time with zeros so xx:xx.xx
		set AppleScript's text item delimiters to ":"
		--if x:xx.xx
		if the length of (the first text item of theTime) is equal to 1 then
			set theTime to "0" & theTime
		end if
		
		--figure out which disc number and which track it is on this disc
		--also pad a single digit track number with a leading zero
		set outputTrackNum to ""
		if trackNum is less than 10 then
			set outputTrackNum to "0" & trackNum as Unicode text
		else
			set outputTrackNum to trackNum as Unicode text
		end if
		--end which disc/track num? -------------
		if j is equal to numOfLines then
			--it's the total for disc
			set returnString to returnString & return & "Total: " & theTime & return & return & return
		else --not total, it's a track
			if trackNamesExist then
				if trackNameCount is greater than (count of trackNames) then
					--if we gave fewer tracknames than tracks, we screwed up.  put question marks in
					set trackName to "???"
				else
					set trackName to (item trackNameCount of trackNames) as Unicode text
					set trackName to padTracknames(trackName, maxTrackNameLength)
				end if
				
				set returnString to returnString & outputTrackNum & space & trackName & space & theTime & return
				set trackNameCount to trackNameCount + 1
			else
				set returnString to returnString & outputTrackNum & space & theTime & return
			end if
		end if
		
		set AppleScript's text item delimiters to return
		set trackNum to trackNum + 1
	end repeat
	
	if trackNamesExist then
		set trackNames to {}
	end if
	
	return returnString
end writeShnLenParsed

on removePath(theLine)
	
	--the output of shnlen has filename starting after character 50
	set theFullPath to ""
	set chars to every character of theLine
	
	repeat with i from 51 to length of chars
		set theFullPath to theFullPath & item i of chars as Unicode text
		set item i of chars to ""
	end repeat
	set AppleScript's text item delimiters to "/"
	set theFilename to the last text item of theFullPath
	set AppleScript's text item delimiters to ""
	set chars to every item of chars as Unicode text
	set theLine to chars & theFilename
	return theLine
end removePath

on getEncodedFileNames(encodeOutput)
	--change for shntool 3.0
	set AppleScript's text item delimiters to " --> ["
	set theLine to text item 2 of encodeOutput
	set AppleScript's text item delimiters to "] : OK"
	set fileName to the first text item of theLine
	set fileName to the unix_path(fileName)
	return fileName
end getEncodedFileNames

on getFixedFileNames(fixOutput)
	set returnList to {} as list
	set AppleScript's text item delimiters to ") --> ["
	set howmany to the number of text items of fixOutput
	repeat with i from 2 to howmany
		set theLine to text item i of fixOutput
		set AppleScript's text item delimiters to "] : OK"
		set fileName to the first text item of theLine
		set returnList to returnList & unix_path(fileName)
		set AppleScript's text item delimiters to " --> "
	end repeat
	
	return returnList
end getFixedFileNames


on md5ByDisc(theFixedSHNs)
	set md5List to {} as list
	set theSHNs to {} as list
	repeat with i in theFixedSHNs
		set iPath to (i as Unicode text)
		
		--set theFiles to theFiles & space & iPath
		set AppleScript's text item delimiters to "/"
		
		
		--take the disc number after the last "d" and create md5 for that
		set AppleScript's text item delimiters to "d"
		set afterDisc to the last text item of iPath
		
		set chars to every character of afterDisc
		set discNumber to (item 1 of chars as number)
		
		--new code added 10/14/03
		--if format is d01t01, then skip the zero and get the number
		if discNumber is equal to 0 then
			set discNumber to (item 2 of chars as number)
		end if
		--end new code 10/14/02
		
		
		--there's a list of md5Files (list of SHN lists)
		--get the item for the discNumber
		--if item doesn't exist, create it and add the current shn file
		--if already exists, grab that list, add the file to the list
		if discNumber is greater than the length of md5List then
			
			set theSHNs to {} as list
			set theSHNs to theSHNs & iPath
			set md5List to md5List & theSHNs
			
		else --there's already a shn file associated with this md5
			
			set theSHNs to {} as list
			set theSHNs to item discNumber of md5List as list
			set theSHNs to theSHNs & iPath
			set item discNumber of md5List to theSHNs
		end if
	end repeat
	
	return md5List
end md5ByDisc


--this method will display only the options that are relevant to the selected function
on displayRelevantOptions()
	set theSHNtoolTab to tab view item "shntoolTab" of tab view "tabs" of window "mainWindow"
	set theEncodetab to tab view item "encodetab" of tab view "tabs" of window "mainWindow"
	set theFixtab to tab view item "fixTab" of tab view "tabs" of window "mainWindow"
	set theUtilTab to tab view item "utilTab" of tab view "tabs" of window "mainWindow"
	set theLossyTab to tab view item "lossyTab" of tab view "tabs" of window "mainWindow"
	
	set visible of button "inputNames" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to false
	
	--encode tab: if shn, disable the slider, verify, "fastest" and "smallest" strings
	--if flac, enable above, disable generate md5 checkbox
	--if ape, disable everything except ape slider
	if (the current tab view item of tab view "tabs" of window "mainWindow" is equal to theEncodetab) then
		if the current column of matrix "encodeFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
			if the current row of matrix "encodeFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
				set enabled of slider "qualitySlider" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of button "verifyCheckbox" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of button "laxCheckbox" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of slider "apeSlider" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of button "generateMD5" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to true
				set enabled of matrix "wavpackFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
			else if the current row of matrix "encodeFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" is equal to 2 then
				--set to flac options, hide SHN options
				set enabled of slider "qualitySlider" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to true
				set enabled of button "verifyCheckbox" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to true
				set enabled of button "laxCheckbox" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to true
				set enabled of button "generateMD5" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of slider "apeSlider" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of matrix "wavpackFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
			else if the current row of matrix "encodeFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" is equal to 3 then
				--if ape, hide all options for shn and flac
				set enabled of slider "qualitySlider" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of button "verifyCheckbox" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of button "laxCheckbox" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of button "generateMD5" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of slider "apeSlider" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to true
				set enabled of matrix "wavpackFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
			end if
		else --column 2, wavpack or tta
			if the current row of matrix "encodeFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
				--wavpack
				set enabled of slider "qualitySlider" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of button "verifyCheckbox" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of button "laxCheckbox" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of slider "apeSlider" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of button "generateMD5" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of matrix "wavpackFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to true
			else if the current row of matrix "encodeFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" is greater than 1 then
				--tta or alac
				set enabled of slider "qualitySlider" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of button "verifyCheckbox" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of button "laxCheckbox" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of slider "apeSlider" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of button "generateMD5" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
				set enabled of matrix "wavpackFormat" of view of tab view item "encodeTab" of tab view "tabs" of window "mainWindow" to false
			end if
		end if
	end if
	
	--shntool tab: if shntool, let shnlen options be shown, hide others.
	--if split or join, hide the len options but show the output options
	
	if (the current tab view item of tab view "tabs" of window "mainWindow" is equal to theSHNtoolTab) then
		if the current row of matrix "shntoolCmd" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
			
			if the current column of matrix "shntoolCmd" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
				-- if shnlen
				set visible of text field "joinSplitFormatText" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to false
				set visible of matrix "joinSplitFormat" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to false
				set visible of matrix "shnlenOptions" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to true
				
				--find out which shnlen option is selected
				set shnlenOptions to the current row of matrix "shnlenOptions" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow"
				
				--if len by fileset or disc, show the names button
				if shnlenOptions is greater than 1 then
					set visible of button "inputNames" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to true
				else -- hide the names button
					set visible of button "inputNames" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to false
				end if
				
			else if the current column of matrix "shntoolCmd" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" is equal to 3 then
				--if shnjoin
				set visible of matrix "shnlenOptions" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to false
				set visible of text field "joinSplitFormatText" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to true
				set visible of matrix "joinSplitFormat" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to true
			else if the current column of matrix "shntoolCmd" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" is equal to 4 then
				--if shnsplit
				set visible of matrix "shnlenOptions" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to false
				set visible of text field "joinSplitFormatText" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to true
				set visible of matrix "joinSplitFormat" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to true
			else --if shninfo or cmp
				set visible of matrix "shnlenOptions" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to false
				set visible of text field "joinSplitFormatText" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to false
				set visible of matrix "joinSplitFormat" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to false
			end if
		else
			--trim
			set visible of matrix "shnlenOptions" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to false
			set visible of text field "joinSplitFormatText" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to true
			set visible of matrix "joinSplitFormat" of view of tab view item "shntoolTab" of tab view "tabs" of window "mainWindow" to true
		end if
	end if
	
	--for fix tab, only show md5 options for shn output
	if (the current tab view item of tab view "tabs" of window "mainWindow" is equal to theFixtab) then
		if the current column of matrix "fixFormat" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
			set enabled of matrix "fixMD5Option" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" to true
			set enabled of slider "fixFlacSlider" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" to false
		else if the current column of matrix "fixFormat" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" is equal to 2 then
			--set visible of text field "fixMD5OptionsText" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" to false
			set enabled of slider "fixFlacSlider" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" to true
			set enabled of matrix "fixMD5Option" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" to false
		else
			set enabled of matrix "fixMD5Option" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" to false
			set enabled of slider "fixFlacSlider" of view of tab view item "fixTab" of tab view "tabs" of window "mainWindow" to false
			
		end if
	end if
	
	--for util tab, only show extraction output options when extraction is selected
	if (the current tab view item of tab view "tabs" of window "mainWindow" is equal to theUtilTab) then
		if the current column of matrix "utilOptions" of view of tab view item "utilTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
			set visible of matrix "extractionOutputOptions" of view of tab view item "utilTab" of tab view "tabs" of window "mainWindow" to false
			set visible of button "separateTrackFlag" of view of tab view item "utilTab" of tab view "tabs" of window "mainWindow" to false
		else --if the current column of matrix "extractionOutputOptions" of view of tab view item "util" of tab view "tabs" of window "mainWindow" is equal to 2 then
			set visible of matrix "extractionOutputOptions" of view of tab view item "utilTab" of tab view "tabs" of window "mainWindow" to true
			set visible of button "separateTrackFlag" of view of tab view item "utilTab" of tab view "tabs" of window "mainWindow" to true
		end if
	end if
	
	--for lossy tab, only show combo if cbr, only show slider if vbr
	if (the current tab view item of tab view "tabs" of window "mainWindow" is equal to theLossyTab) then
		
		set enabled of matrix "lameOptions" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to false
		set enabled of matrix "aacOptions" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to false
		set enabled of slider "lameVBRSlider" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to false
		set enabled of text field "aacVBRStepperText" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to false
		set enabled of stepper "aacVBRStepper" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to false
		set enabled of cell "aacOption" of matrix "lossyFormat" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to false
		set enabled of combo box "lossyBitrateCombo" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to false
		
		if leopardFlag is true then
			set enabled of cell "aacOption" of matrix "lossyFormat" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to true
			--set enabled of cell "aacOption" of matrix "lossyFormat" of window "mainWindow" to true
		else
			--set enabled of cell "aacOption" of matrix "lameOptions" of window "mainWindow" to false
		end if
		
		if the current row of matrix "lossyFormat" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
			set enabled of matrix "lameOptions" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to true
			
			if the current row of matrix "lameOptions" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
				--CBR
				set enabled of combo box "lossyBitrateCombo" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to true
			else --if the current row of matrix "lameOptions" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" is equal to 2 then
				set enabled of slider "lameVBRSlider" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to true
			end if
			
		else --		if the current row of matrix "lossyFormat" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" is equal to 2 then
			--aac
			set enabled of matrix "aacOptions" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to true
			
			if the current row of matrix "aacOptions" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
				--CBR
				set enabled of combo box "lossyBitrateCombo" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to true
			else if the current row of matrix "aacOptions" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" is equal to 2 then
				--ABR
				set enabled of combo box "lossyBitrateCombo" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to true
			else if the current row of matrix "aacOptions" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" is equal to 3 then
				--VBR Constrained
				set enabled of combo box "lossyBitrateCombo" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to true
			else --			if the current row of matrix "aacOptions" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" is equal to 4 then
				--VBR				
				set enabled of stepper "aacVBRStepper" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to true
				set enabled of text field "aacVBRStepperText" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to true
			end if
		end if
	end if
	
	
end displayRelevantOptions

on checkFormat(iPath)
	set format to ""
	
	set infoResult to do shell script shellPath & "shntool info" & space & getQuotedForm(iPath) & " 2>&1"
	if infoResult contains "is not handled by any of the builtin format modules" then
		return "unknown"
	end if
	
	set AppleScript's text item delimiters to return
	set theLine to text item 3 of infoResult
	if theLine contains "wav format module" then
		set format to "wav"
	else if theLine contains "aiff format module" then
		set format to "aiff"
	else
		set format to "other"
	end if
	
	return format
end checkFormat

on check16Bit(iPath)
	
	set infoResult to do shell script shellPath & "shntool info" & space & getQuotedForm(iPath) & " 2>&1"
	if infoResult contains "is not handled by any of the builtin format modules" then
		return "unknown"
	end if
	
	set AppleScript's text item delimiters to return
	set theLine to text item 7 of infoResult
	if theLine contains "16" then
		return true
	else
		return false
	end if
end check16Bit


on isALAC(iPath)
	if leopardFlag is false then
		display alert "Leopard is required to handle .m4a file " & iPath
		return false
	end if
	
	try
		set infoResult to do shell script shellPath & "afinfo" & space & getQuotedForm(iPath) & " 2>&1"
		
		set AppleScript's text item delimiters to return
		set theLine to text item 3 of infoResult
		if theLine contains "'alac'" then
			return true
		else
			return false
		end if
	on error errorStr number errorNum
		return false
	end try
end isALAC

on getAlacBitrate(iPath)
	if leopardFlag is false then
		display alert "Leopard is required to handle .m4a file " & iPath
		return false
	end if
	
	try
		set infoResult to do shell script shellPath & "afinfo" & space & getQuotedForm(iPath) & " 2>&1"
		
		set AppleScript's text item delimiters to return
		set theLine to text item 3 of infoResult
		if theLine contains "16-bit" then
			return "16-bit"
		else if theLine contains "24-bit" then
			return "24-bit"
		else
			return "other"
		end if
	on error errorStr number errorNum
		return false
	end try
end getAlacBitrate


on getMACError(errorCode)
	if errorCode contains "1000" then
		return "I/O read error"
	else if errorCode contains "1001" then
		return "I/O write error"
	else if errorCode contains "1002" then
		return "invalid input file"
	else if errorCode contains "1003" then
		return "invalid output file"
	else if errorCode contains "1004" then
		return "input file too large"
	else if errorCode contains "1005" then
		return "input file unsupported bit depth"
	else if errorCode contains "1006" then
		return "input file unsupported sample rate"
	else if errorCode contains "1007" then
		return "input file unsupported channel count"
	else if errorCode contains "1008" then
		return "input file too small"
	else if errorCode contains "1009" then
		return "invalid checksum"
	else if errorCode contains "1010" then
		return "decompressing frame"
	else if errorCode contains "1011" then
		return "initializing unmac"
	else if errorCode contains "1012" then
		return "invalid function parameter"
	else if errorCode contains "1013" then
		return "unsupported file type"
	else if errorCode contains "2000" then
		return "insufficient memory"
	else
		return "undefined"
		
	end if
	
end getMACError

on parseFLACVerify(theResults)
	--grab from the last "%complete" line on.
	--so, instead of starting at the end, grabbing each line, prepending the one before, until the line contains "% complete",
	--we just reverse the list and go until the first "% complete"
	
	set theOutput to ""
	
	set AppleScript's text item delimiters to return
	set theList to the text items in theResults
	set theList to (reverse of theList)
	
	repeat with i in theList
		set theOutput to (i as Unicode text) & return & theOutput
		if (i as Unicode text) contains "% complete" then
			return theOutput
		end if
	end repeat
end parseFLACVerify

on parseWavpackVerify(theResults)
	--grab from the last "% done" line on.
	--so, instead of starting at the end, grabbing each line, prepending the one before, until the line contains "% complete",
	--we just reverse the list and go until the first "% done"
	
	set theOutput to ""
	
	set AppleScript's text item delimiters to return
	set theList to the text items in theResults
	set theList to (reverse of theList)
	
	repeat with i in theList
		set theOutput to (i as Unicode text) & return & theOutput
		if (i as Unicode text) contains "% done" then
			return theOutput
		end if
	end repeat
	
end parseWavpackVerify


on parseAPEVerify(theResults)
	--grab from the last "Progress:" line on.
	--we reverse the list and go until the first "Progress:"
	
	set theOutput to ""
	
	set AppleScript's text item delimiters to return
	set theList to the text items in theResults
	set theList to (reverse of theList)
	
	repeat with i in theList
		set theOutput to (i as Unicode text) & return & theOutput
		if (i as Unicode text) contains "Progress:" then
			return theOutput
		end if
	end repeat
end parseAPEVerify

on parseAPEError(theResults)
	--grab the "Error" line, which is last in the output
	
	set theOutput to ""
	
	set AppleScript's text item delimiters to return
	set theError to the last text item of theResults
	
	set theOutput to theError & ": " & getMACError(theResults)
	
	return theOutput
	
end parseAPEError

on getFileName(iPath)
	set fileName to ""
	
	set AppleScript's text item delimiters to "/"
	
	return fileName
end getFileName


on showTags(theFile)
	
	--flac 1.1.1 changes:
	--show-vc-vendor becomes --show-vendor-tag
	--show-vc-field becomes --show-tag
	--remove-vc-all becomes --remove-all-tags
	--remove-vc-field becomes --remove-tag
	--remove-vc-firstfield becomes --remove-first-tag
	--set-vc-field becomes --set-tag
	--import-vc-from becomes --import-tags-from
	--export-vc-to becomes --export-tags-to
	
	set theName to stripEquals(do shell script shellPath & "metaflac --show-tag=TITLE " & getQuotedForm(theFile))
	set theArtist to stripEquals(do shell script shellPath & "metaflac --show-tag=ARTIST " & getQuotedForm(theFile))
	set theDate to stripEquals(do shell script shellPath & "metaflac --show-tag=DATE " & getQuotedForm(theFile))
	set theAlbum to stripEquals(do shell script shellPath & "metaflac --show-tag=ALBUM " & getQuotedForm(theFile))
	set theComment to stripEquals(do shell script shellPath & "metaflac --show-tag=COMMENT " & getQuotedForm(theFile))
	set theGenre to stripEquals(do shell script shellPath & "metaflac --show-tag=GENRE " & getQuotedForm(theFile))
	set theTrackNumber to stripEquals(do shell script shellPath & "metaflac --show-tag=TRACKNUMBER " & getQuotedForm(theFile))
	set theDiscNumber to stripEquals(do shell script shellPath & "metaflac --show-tag=DISCNUMBER " & getQuotedForm(theFile))
	set theComposer to stripEquals(do shell script shellPath & "metaflac --show-tag=COMPOSER " & getQuotedForm(theFile))
	
	set string value of text field "nameTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to theName
	set string value of text field "artistTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to theArtist
	set string value of text field "dateTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to theDate
	set string value of text field "albumTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to theAlbum
	set string value of text field "commentTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to theComment
	set string value of text field "trackNumberTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to theTrackNumber
	set string value of text field "discNumberTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to theDiscNumber
	set string value of text field "genreTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to theGenre
	set string value of text field "composerTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to theComposer
	
end showTags

on changeTags(theFile, multipleSelections)
	
	set theName to string value of text field "nameTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow"
	set theArtist to string value of text field "artistTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow"
	set theDate to string value of text field "dateTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow"
	set theLocation to string value of text field "albumTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow"
	set theComment to string value of text field "commentTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow"
	set theGenre to string value of text field "genreTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow"
	set theTrackNumber to string value of text field "trackNumberTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow"
	set theDiscNumber to string value of text field "discNumberTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow"
	set theComposer to string value of text field "composerTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow"
	
	
	
	try
		writeTags(theFile, "ARTIST", theArtist)
		writeTags(theFile, "DATE", theDate)
		writeTags(theFile, "ALBUM", theLocation)
		writeTags(theFile, "COMMENT", theComment)
		writeTags(theFile, "GENRE", theGenre)
		writeTags(theFile, "COMPOSER", theComposer)
		writeTags(theFile, "DISCNUMBER", theDiscNumber)
		
		if multipleSelections is equal to false then
			writeTags(theFile, "TITLE", theName)
			writeTags(theFile, "TRACKNUMBER", theTrackNumber)
		end if
	on error errorStr number errorNum
		display dialog ("error writing tags for: " & theFile) buttons {"OK"} default button "OK" with icon 0 giving up after 20
		set errorLog to errorLog & theFile & ": " & errorStr & return
	end try
	
end changeTags

on writeTags(theFile, field, value)
	
	--flac 1.1.1 changes:
	--show-vc-vendor becomes --show-vendor-tag
	--show-vc-field becomes --show-tag
	--remove-vc-all becomes --remove-all-tags
	--remove-vc-field becomes --remove-tag
	--remove-vc-firstfield becomes --remove-first-tag
	--set-vc-field becomes --set-tag
	--import-vc-from becomes --import-tags-from
	--export-vc-to becomes --export-tags-to
	
	set emptyTags to the state of button "writeEmptyTags" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow"
	
	if value is not equal to "" then --if tag is not empty, write it
		do shell script shellPath & "metaflac --remove-tag=" & field & space & getQuotedForm(theFile) & " 2>&1"
		do shell script shellPath & "metaflac --set-tag=" & field & "=\"" & value & "\" " & getQuotedForm(theFile) & " 2>&1"
	else if value is equal to "" and emptyTags is equal to 1 then --if it's empty and we want to write empty tags
		do shell script shellPath & "metaflac --remove-tag=" & field & space & getQuotedForm(theFile) & " 2>&1"
		do shell script shellPath & "metaflac --set-tag=" & field & "=\"" & value & "\" " & getQuotedForm(theFile) & " 2>&1"
	end if
end writeTags

on clearFlacTags()
	set string value of text field "nameTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to ""
	set string value of text field "artistTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to ""
	set string value of text field "dateTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to ""
	set string value of text field "albumTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to ""
	set string value of text field "commentTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to ""
	set string value of text field "genreTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to ""
	set string value of text field "trackNumberTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to ""
	set string value of text field "discNumberTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to ""
	set string value of text field "composerTag" of view of tab view item "tagTab" of tab view "tabs" of window "mainWindow" to ""
	
end clearFlacTags


on handleBatchRename()
	set theReply to display dialog "Enter the Prefix that you want the files to start with:" default answer ""
	set prefix to text returned of theReply
	
	set theNumber to 1 as integer
	
	--if user entered special char (space?), deal with it
	set prefix to unix_path(prefix)
	
	--how do i deal with files that may not have an extension?  just add extension to all?
	set extensionFlag to false
	set askedExtensionFlag to false
	set extension to ""
	
	--prompt if a file has a period?
	repeat with i in utilPaths
		set iPath to (i as Unicode text)
		set dir to get_Directory(iPath)
		
		if askedExtensionFlag is equal to false then
			if iPath contains "." then
				set dialogText to "xACT has found a period in one or more paths.  Do you want me to treat it as an extension or ignore?"
				--set dialogMessage to "Do you need me to install Shorten, FLAC, SHNtool, md5sum, and sox into /usr/local/bin?"
				set dialogType to critical
				set defaultButtonTitle to "Extension"
				set alternateButtonTitle to "Ignore"
				
				set theReply to display alert dialogText as dialogType default button defaultButtonTitle alternate button alternateButtonTitle
				if button returned of theReply is equal to "Extension" then
					set extensionFlag to true
					--else do nothing
				end if
				
				set askedExtensionFlag to true
			end if
		end if
		
		if extensionFlag is equal to true and iPath contains "." then
			set AppleScript's text item delimiters to "."
			set extension to "." & the last text item of iPath
		end if
		--maybe make the outlog log this next line
		--display dialog ("renaming from " & iPath & space & "to: " & dir & theInput & theNumber)
		
		set fileNumber to theNumber
		if theNumber is less than 10 then
			set fileNumber to "0" & theNumber
		end if
		do shell script "mv " & getQuotedForm(iPath) & space & getQuotedForm(dir & prefix & fileNumber & extension)
		set theNumber to theNumber + 1
	end repeat
	
	--add some sort of out log to output window	
	set contents of text view "utilList" of scroll view "utilList" of view of tab view item "utilTab" of tab view "tabs" of window "mainWindow" to ""
	set utilPaths to {} as list
	bounceDock()
	
end handleBatchRename

on handleParanoiaExtract()
	set outputDir to choose folder with prompt "Choose Output Folder"
	set outputDir to (POSIX path of outputDir)
	set outputDir to unix_path(outputDir)
	
	set theResults to ""
	set theResult to ""
	--repeat with i in utilPaths
	
	set iPath to (item 1 of utilPaths as Unicode text)
	set AppleScript's text item delimiters to "/"
	--set fileName to the last text item of iPath
	--set fileNameNoExtension to get_fileName_no_extension(fileName)
	--display dialog "filename: " & fileName
	
	set trackNumber to getOrder(utilPaths)
	
	--display dialog diskName
	--display dialog diskName
	set theStatusPanel to load panel "StatusPanel" from nib "StatusPanel"
	display panel theStatusPanel attached to window "MainWindow"
	tell theStatusPanel
		tell progress indicator "progressbar"
			set uses threaded animation to true
			set indeterminate to true
			start
		end tell
		set AppleScript's text item delimiters to "+"
		
		set statusMessage to "Extracting tracks " & (text item 1 of trackNumber) & " to " & (text item 2 of trackNumber) & "...  "
		set contents of text field "statusMessage" to statusMessage
		call method "display" of text field "statusMessage"
	end tell
	
	set dir to get_Directory(iPath)
	set diskName to callDisktool(dir)
	
	set IOProviderClass to getProviderClass(diskName)
	
	do shell script "disktool -u " & diskName
	--do shell script "diskutil unmount " & diskName
	
	set outputFormat to ""
	if the current row of matrix "extractionOutputOptions" of view of tab view item "utilTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
		set outputFormat to "wav"
	else
		set outputFormat to "wav"
	end if
	if the state of button "separateTrackFlag" of view of tab view item "utilTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
		set separateTrackFlag to ""
	else
		set separateTrackFlag to "-B "
	end if
	try
		set theResult to do shell script shellPath & ("cd " & getQuotedForm(outputDir) & "; cdda2wav " & separateTrackFlag & "-L 1 -H -t " & trackNumber & " -paranoia -O" & outputFormat & " dev=" & IOProviderClass & " 2>&1")
	on error errorStr
		set theResult to errorStr
		if errorStr contains "Cannot open SCSI driver" then
			display dialog "Error finding the cd drive" buttons {"OK"} default button "OK" with icon 0 giving up after 20
		end if
	end try
	tell progress indicator "progressbar" of window "StatusPanel" to stop
	close panel window "StatusPanel"
	
	set theResults to theResults & theResult & return & return
	
	set theResults to parseCdda2WavResults(theResults)
	makeMessageWindow(theResults)
	
	renameExtractedTracks(trackNumber, outputDir, outputFormat)
	
	set contents of text view "utilList" of scroll view "utilList" of view of tab view item "utilTab" of tab view "tabs" of window "mainWindow" to ""
	set utilPaths to {} as list
	
	bounceDock()
	
end handleParanoiaExtract

on parseCdda2WavResults(theResults)
	set parsedResults to ""
	
	set AppleScript's text item delimiters to return
	
	repeat with i in (text items of theResults)
		if i ends with "%" then
			--ignore
		else
			set parsedResults to parsedResults & i & return
		end if
		
	end repeat
	
	return parsedResults
end parseCdda2WavResults

on callDisktool(dir)
	-- run disktool -l
	set disktoolResults to do shell script "disktool -l"
	set AppleScript's text item delimiters to return
	
	--set disktoolTokens to {} as list
	repeat with i in (text items of disktoolResults)
		if i contains "fsType = 'cddafs'" then
			set i to (i as string)
			--get tokens.  sample format is:
			--***Disk Appeared ('disk2',Mountpoint = '/Volumes/Audio CD', fsType = 'cddafs', volName = 'Audio CD')
			set AppleScript's text item delimiters to "'"
			--repeat with j from 1 to (number of text items in i)
			--if j mod 2 is equal to 0 then
			--	set disktoolTokens to disktoolTokens & (text item j of i as unicode text)
			--	display dialog (text item j of i)
			--end if
			--token list format:
			--1: disk name we can reference in disktool
			--2: Mountpoint
			--3: fsType:
			--4: volname
			set diskName to (text item 2 of i)
			--			set mountpoint to unix_path(text item 4 of i)
			--			--display dialog ("dir: " & dir & "  -- mountpoint: " & mountpoint)
			--			if (mountpoint & "/") is equal to dir then
			--				return diskName
			--			end if
			set AppleScript's text item delimiters to "Mountpoint = '"
			set mountpoint to unix_path(text item 2 of i)
			
			set chars to every character of dir
			set newDir to ""
			repeat with i from 1 to ((length of chars) - 1)
				set newDir to newDir & item i of chars
			end repeat
			if (mountpoint) starts with (newDir) then
				return diskName
			end if
			
			--end repeat
		end if
		set AppleScript's text item delimiters to return
	end repeat
	return "error"
end callDisktool

on getOrder(myList)
	set myList to reNumberCdTracks(myList)
	
	
	--display dialog ("isInOrder")
	set tracksString to ""
	set startNumber to -1
	set endNumber to 0
	
	set trackInteger to 0
	repeat with i in myList
		set fileName to i as Unicode text
		
		set AppleScript's text item delimiters to " "
		set trackNumber to text item 1 of fileName
		set trackInteger to trackNumber as integer
		if startNumber = -1 then
			set startNumber to trackInteger
			set endNumber to trackInteger
		else if endNumber = (trackInteger - 1) then
			set endNumber to trackInteger
		end if
		
	end repeat
	
	set tracksString to (startNumber as Unicode text) & "+" & (endNumber as Unicode text)
	--display dialog (tracksString)
	
	return tracksString
end getOrder

on reNumberCdTracks(myList)
	set trackList to {} as list
	
	repeat with i in myList
		set iPath to (i as Unicode text)
		set AppleScript's text item delimiters to "/"
		set fileName to the last text item of iPath
		--the track number is followed by a space (\ ")
		set AppleScript's text item delimiters to " "
		set trackNumber to text item 1 of fileName
		
		set trackInteger to trackNumber as integer
		
		if trackInteger < 10 and trackNumber does not start with "0" then
			set newFileName to "0" & fileName
		else
			set newFileName to fileName
		end if
		set trackList to trackList & newFileName
	end repeat
	
	set trackList to ASCII_Sort(trackList)
	
	
	return trackList
end reNumberCdTracks


on getProviderClass(diskNumber)
	--ioreg -l -w 0 | egrep "("\"BSD\ Name\"\ =\ \"disk1\""|"\"IOProviderClass\"\ =\ \"IODVDServices"|"\"IOProviderClass\"\ =\ \"IOCompactDiscServices")"
	--ioreg -l -w 0 | egrep "("\"BSD\ Name\"\ =\ \"disk1\""|"+-o\ IODVDServices\ \ \<class\ IODVDServices"|"+-o\ IOCompactDiscServices\ \ \<class\ IOCompactDiscServices")"
	
	--set theCommand to "ioreg -l -w 0 | egrep \"(\"\\\"BSD\\ Name\\\"\\ =\\ \\\"" & diskNumber & "\\\"\"|\"\\\"IOProviderClass\\\"\\ =\\ \\\"IODVDServices\"|\"\\\"IOProviderClass\\\"\\ =\\ \\\"IOCompactDiscServices\")\""
	
	set theCommand to "ioreg -l -w 0 | egrep \"(\"\\\"BSD\\ Name\\\"\\ =\\ \\\"" & diskNumber & "\\\"\"|\"+-o\\ IODVDServices\\ \\ \\<class\\ IODVDServices\"|\"+-o\\ IOCompactDiscServices\\ \\ \\<class\\ IOCompactDiscServices\")\""
	
	
	--added 11/6/2004 to check on something other than provider class.  
	--now i'll check on the main class and check the drives listed for each.  it'll look like this:
	--| |   |   |           +-o IODVDServices  <class IODVDServices, registered, matched, active, busy 0, retain count 6>
	--| |   |   |             | | |   "BSD Name" = "disk1"
	--| |   |       | |   |     +-o IOCompactDiscServices  <class IOCompactDiscServices, registered, matched, active, busy 0, retain count 6>
	
	--so, we want to find results like above. If line contains IODVDServices, keep track of how many
	--if 2, we want IODVDServices/2
	--makes sense?
	
	
	set theResult to do shell script theCommand
	
	--OLD WAY RESULTS
	--result might look something like this
	--    | |   |   |             |     "IOProviderClass" = "IODVDServices"
	--    | |   |   |               | |   "BSD Name" = "disk1"
	--end OLD WAY RESULTS
	
	--we want to:
	--1. get a provider name
	--2. look to see if bsd name is next.  if not, and it's provider class, store that
	--3. we eventually want a provider class and bsd name
	
	--OLD WAY-----------------
	--	set IOProviderClass to ""
	--	set theDelimiter to return
	--	set AppleScript's text item delimiters to theDelimiter
	--	repeat with i from 1 to (the number of text items in theResult)
	--		set theLine to (text item i of theResult)
	
	--		if theLine contains "\"IOProviderClass\" =" then
	--			set AppleScript's text item delimiters to "="
	--			set IOProviderClass to the last text item of theLine
	--			display dialog IOProviderClass
	--			set AppleScript's text item delimiters to "\""
	--			--remove quotes from the IOProviderClass
	--			set IOProviderClass to text item 2 of IOProviderClass
	--			display dialog IOProviderClass
	--		else if theLine contains "\"BSD Name\" = \"" & diskNumber & "\"" and IOProviderClass is not equal to "" then
	--			--display dialog IOProviderClass
	--			return IOProviderClass
	--		end if
	--		set AppleScript's text item delimiters to theDelimiter
	--		
	--	end repeat
	--end old way------------------
	
	--new way on 11/6/2004
	set IODVDServicesCount to 0
	set IOCompactDiscServicesCount to 0
	set IOProviderClass to ""
	set theDelimiter to return
	set AppleScript's text item delimiters to theDelimiter
	repeat with i from 1 to (the number of text items in theResult)
		set theLine to (text item i of theResult)
		
		if theLine contains "IODVDServices" then
			set IODVDServicesCount to IODVDServicesCount + 1
			
			if IODVDServicesCount > 1 then
				set IOProviderClass to "IODVDServices/" & IODVDServicesCount
			else --it's just the first
				set IOProviderClass to "IODVDServices"
			end if
		else if theLine contains "IOCompactDiscServices" then
			set IOCompactDiscServicesCount to IOCompactDiscServicesCount + 1
			
			if IOCompactDiscServicesCount > 1 then
				set IOProviderClass to "IOCompactDiscServices/" & IOCompactDiscServicesCount
			else --it's just the first
				set IOProviderClass to "IOCompactDiscServices"
			end if
		else if theLine contains "\"BSD Name\" = \"" & diskNumber & "\"" and IOProviderClass is not equal to "" then
			--display dialog IOProviderClass
			return IOProviderClass
		end if
		set AppleScript's text item delimiters to theDelimiter
		
	end repeat
	
	--end 11/6/2004 way
	
end getProviderClass

--code to rename extracted tracks according to cddb
on renameExtractedTracks(trackNumber, outputDir, outputFormat)
	
	set AppleScript's text item delimiters to "+"
	set trackNumber1 to text item 1 of trackNumber as integer
	set tracknumber2 to text item 2 of trackNumber as integer
	
	
	--find out if we extracted multiple tracks
	set multipleTracks to false as boolean
	set difference to tracknumber2 - trackNumber1
	if difference is greater than 0 then
		set multipleTracks to true
	end if
	
	--find out if we split to separate tracks
	if the state of button "separateTrackFlag" of view of tab view item "utilTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
		set separateTracks to false
	else
		set separateTracks to true
	end if
	
	--now only rename files if
	--1. we extracted 1 track, regardless of separate track flag
	--2. we extracted multiple to separate tracks
	if (multipleTracks is equal to false) or (multipleTracks is equal to true and separateTracks is equal to true) then
		set cddbList to {} as list
		set AppleScript's text item delimiters to "/"
		repeat with i in utilPaths
			set iPath to (i as Unicode text)
			set cddbList to cddbList & (the last text item of iPath)
		end repeat
		
		set cddbList to reNumberCdTracks(cddbList)
		--if we only have one track, cdda2wav names it audio.xxx where xxx is file format extension	
		if multipleTracks is equal to false then
			set theCommand to "cd " & getQuotedForm(outputDir) & " ; mv audio." & outputFormat & " " & getQuotedForm(get_fileName_no_extension(item 1 of cddbList)) & "." & outputFormat
			do shell script theCommand
		else --if multiple tracks is true
			set trackNumber to trackNumber1
			repeat with i from 1 to (difference + 1)
				if trackNumber is less than 10 then
					set tracknumberPad to "0"
				else --greater than 10, no padding
					set tracknumberPad to ""
				end if
				
				set theCommand to "cd " & getQuotedForm(outputDir) & " ; mv audio_" & tracknumberPad & trackNumber & "." & outputFormat & " " & getQuotedForm(get_fileName_no_extension(item i of cddbList)) & "." & outputFormat
				set trackNumber to trackNumber + 1
				
				do shell script theCommand
			end repeat
		end if
	end if
end renameExtractedTracks
--code to fade in/fade out the main window on load/unload of application
on ShowWindow()
	setNormalIcon()
	
	set alpha value of window "MainWindow" to 0.0
	set visible of window "MainWindow" to true
	set opacity to 0.0
	repeat while opacity < 0.9
		set alpha value of window ("MainWindow") to opacity
		set opacity to opacity + 0.1
		delay 0.05
	end repeat
	set alpha value of window ("MainWindow") to 1.0
	
end ShowWindow

on HideWindow()
	set opacity to 1.0
	repeat while opacity > 0.1
		set alpha value of window ("MainWindow") to opacity
		
		set opacity to opacity - 0.1
		delay 0.05
	end repeat
	set alpha value of window ("MainWindow") to 0.0
	
	setNormalIcon()
end HideWindow

on getQuotedForm(s)
	return quoted form of s
end getQuotedForm


on setDecodingIcon()
	set a to load image ("decoding.icns") --already added image to your project
	tell me
		set icon image to a
	end tell
end setDecodingIcon

on setFixingIcon()
	set a to load image ("fixing.icns") --already added image to your project
	tell me
		set icon image to a
	end tell
end setFixingIcon

on setEncodingIcon()
	set a to load image ("encoding.icns") --already added image to your project
	tell me
		set icon image to a
	end tell
end setEncodingIcon

on setNormalIcon()
	set a to load image ("xACT.icns") --already added image to your project
	tell me
		set icon image to a
	end tell
end setNormalIcon

on bounceDock()
	set requestType to 10
	call method "requestUserAttention:" of class "NSApp" with parameter requestType
	
end bounceDock

on handleLossyEncodeClick()
	setEncodingIcon()
	
	set sameOutputDirectory to the state of button "sourceLossyEncode" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow"
	
	if sameOutputDirectory is 1 then
		set outputPath to null
	else
		set outputPath to choose folder
		set outputPath to (POSIX path of outputPath)
		set outputPath to unix_path(outputPath)
	end if
	
	set theStatusPanel to load panel "StatusPanel" from nib "StatusPanel"
	display panel theStatusPanel attached to window "MainWindow"
	
	set theResult to ""
	repeat with i in lossyPaths
		set iPath to (i as Unicode text)
		set AppleScript's text item delimiters to "/"
		set fileName to the last text item of iPath
		tell theStatusPanel
			tell progress indicator "progressbar"
				set uses threaded animation to true
				set indeterminate to true
				start
			end tell
			
			set statusMessage to "Encoding...  " & fileName
			
			set contents of text field "statusMessage" to statusMessage
			call method "display" of text field "statusMessage"
		end tell
		
		set theResult to theResult & compressLossy(iPath, outputPath) & return & return & "--------------------" & return
		
	end repeat
	tell progress indicator "progressbar" of window "StatusPanel" to stop
	set contents of text field "statusMessage" of window "StatusPanel" to ""
	close panel window "StatusPanel"
	
	set contents of text view "lossyList" of scroll view "lossyList" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" to ""
	
	
	set deleteLossyEncode to the state of button "deleteLossyEncode" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow"
	
	
	if errorLog is not equal to "" then
		makeMessageWindow(errorLog)
	else --no error
		if deleteLossyEncode is 1 then
			repeat with i in encodePaths
				set iPath to (i as Unicode text)
				set deunixpath to de_unix_path(iPath)
				set macPath to POSIX file deunixpath
				tell application "Finder"
					delete macPath
				end tell
				--do shell script "mv " & iPath & " ~/.Trash/"
			end repeat
		end if
		makeMessageWindow(theResult)
	end if
	
	set lossyPaths to {} as list
	set errorLog to ""
	set errorFlag to false
	
	setNormalIcon()
	bounceDock()
	
end handleLossyEncodeClick

on compressLossy(iPath, outputPath)
	
	set theResult to ""
	if outputPath is null then
		set lossyOutputDir to get_Directory(iPath)
	else
		set lossyOutputDir to outputPath
	end if
	
	if the current row of matrix "lossyFormat" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
		--LAME mp3
		if the current row of matrix "lameOptions" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
			--row 1 is CBR
			set bitrate to contents of combo box "lossyBitrateCombo" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow"
			
			try
				set theResult to my convertToCBRLAME(iPath, lossyOutputDir, bitrate)
			on error errorStr number errorNum
				display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
				set errorLog to errorLog & return & iPath & ": " & errorStr & return
				
			end try
			
		else
			--VBR
			set vbrLevel to the contents of slider "lameVBRSlider" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" as integer
			
			
			try
				set theResult to my convertToVBRLame(iPath, lossyOutputDir, vbrLevel)
			on error errorStr number errorNum
				if errorStr contains "[2KError:   file(s) not found" then
					
				else
					display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
					set errorLog to errorLog & return & iPath & ": " & errorStr & return
				end if
			end try
		end if
	else --if the current row of matrix "lossyFormat" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" is equal to 2 then
		--aac
		try
			set theResult to my convertToAAC(iPath, lossyOutputDir)
		on error errorStr number errorNum
			display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to errorLog & return & iPath & ": " & errorStr & return
			
		end try
	end if
	return theResult
	
end compressLossy

on convertToCBRLAME(iPath, outputPath, bitrate)
	
	set theCommand to shellPath & "shntool conv -P none -O never -o 'cust ext=mp3 lame -b " & bitrate & " - %f ' " & " -d " & getQuotedForm(outputPath) & space & getQuotedForm(iPath) & " 2>&1"
	--set theCommand to shellPath & "shntool conv -o shn  -d " & getQuotedForm(outputPath) & space & getQuotedForm(iPath) & " 2>&1"
	set theResult to do shell script theCommand
	if theResult contains "error" then
		--set AppleScript's text item delimiters to "."
		--set fileExtension to the last text item of iPath
		--if fileExtension contains "aif" then
		--	--maybe it's AIFC?
		--	convertAIFCToSHN(iPath, outputPath)
		--else
		display dialog theResult buttons {"OK"} default button "OK" with icon 0 giving up after 20
		set errorLog to theResult & return
	end if
	
	if iPath ends with ".flac" then
		try
			set theOutputFile to getEncodedFileNames(theResult)
			tagLameFileFromFlac(iPath, theOutputFile)
		on error erorrStr number errorNum
		end try
	end if
	
	
	makeMessageWindow(theResult)
	return theResult
	
	--end if
end convertToCBRLAME

on convertToAAC(iPath, outputPath)
	--afconvert -f 'm4af' -d 'aac' -b 160000 -v input wav output m4a
	
	set fileToEncode to iPath
	
	--get the filename (no path)
	set AppleScript's text item delimiters to "/"
	set fileName to the last text item of iPath
	
	--if the filename has an extension, we want to drop it
	if fileName contains "." then
		set fileName to get_fileName_no_extension(fileName)
	end if
	
	set AppleScript's text item delimiters to "."
	set fileExtension to the last text item of iPath
	
	set fileNameConverted to ""
	if fileExtension is "flac" or fileExtension is "shn" then
		--need to convert to wav first
		set fileNameConverted to fileName & ".wav"
		try
			set convertCommand to shellPath & "shntool conv -P none -O never -o wav -d " & getQuotedForm(outputPath) & space & getQuotedForm(iPath) & " 2>&1"
			do shell script convertCommand
			
			set fileToEncode to outputPath & fileNameConverted
		on error errorStr number errNum
			set errMsg to "unable to decode to wav before encoding to AAC"
			display dialog errMsg buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to errorLog & errorStr & return
			do shell script "rm " & getQuotedForm(outputPath & fileNameConverted)
			return
		end try
	end if
	
	
	set bitrate to contents of combo box "lossyBitrateCombo" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow"
	set bitrate to bitrate * 1000
	set currentStepperValue to contents of stepper "aacVBRStepper" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow"
	
	if the current row of matrix "aacOptions" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" is equal to 1 then
		--CBR
		set theCommand to shellPath & "afconvert -f m4af -d aac -b " & bitrate & " -s 0 -v " & getQuotedForm(fileToEncode) & space & getQuotedForm(outputPath & fileName & ".m4a") & space & " 2>&1"
	else if the current row of matrix "aacOptions" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" is equal to 2 then
		--ABR
		set theCommand to shellPath & "afconvert -f m4af -d aac -b " & bitrate & " -s 1 -v " & getQuotedForm(fileToEncode) & space & getQuotedForm(outputPath & fileName & ".m4a") & space & " 2>&1"
	else if the current row of matrix "aacOptions" of view of tab view item "lossyTab" of tab view "tabs" of window "mainWindow" is equal to 3 then
		--VBR Constrained
		set theCommand to shellPath & "afconvert -f m4af -d aac -b " & bitrate & " -s 2 -v " & getQuotedForm(fileToEncode) & space & getQuotedForm(outputPath & fileName & ".m4a") & space & " 2>&1"
	else --VBR
		set theCommand to shellPath & "afconvert -f m4af -d aac -s 3 -u vbrq " & currentStepperValue & " -v " & getQuotedForm(fileToEncode) & space & getQuotedForm(outputPath & fileName & ".m4a") & space & " 2>&1"
	end if
	
	set theResult to do shell script theCommand
	if theResult contains "error" then
		display dialog theResult buttons {"OK"} default button "OK" with icon 0 giving up after 20
		set errorLog to theResult & return
	end if
	
	--	if we converted a file to wav first from flac or shn, we need to delete it
	if fileNameConverted is not equal to "" then
		do shell script "rm " & getQuotedForm(fileToEncode)
		--set deunixpath to de_unix_path(fileToEncode)
		--set macPath to POSIX file deunixpath
		--tell application "Finder"
		--	delete macPath
		--end tell
	end if
	
	if iPath ends with ".flac" then
		try
			set theOutputFile to getQuotedForm(outputPath & fileName & ".m4a")
			tagAACFileFromFlac(iPath, theOutputFile)
		on error errorStr number errorNum
			display dialog errorStr
		end try
	end if
	
	makeMessageWindow(theResult)
	
	return theResult
	--end if
end convertToAAC

on convertToVBRLame(iPath, outputPath, vbrLevel)
	set theCommand to shellPath & "shntool conv -P none -O never -o 'cust ext=mp3 lame -V " & vbrLevel & " - %f ' " & "-d " & getQuotedForm(outputPath) & space & getQuotedForm(iPath) & " 2>&1"
	try
		set theResult to do shell script theCommand
		if theResult contains "error" then
			display dialog theResult buttons {"OK"} default button "OK" with icon 0 giving up after 20
			set errorLog to theCommand & return & return & theResult & return
		end if
		
		if iPath ends with ".flac" then
			try
				set theOutputFile to getEncodedFileNames(theResult)
				tagLameFileFromFlac(iPath, theOutputFile)
			on error erorrStr number errorNum
			end try
		end if
		
		makeMessageWindow(theResult)
	on error errorStr number errorNum
		display dialog errorStr buttons {"OK"} default button "OK" with icon 0 giving up after 20
		set errorLog to theCommand & return & return & errorStr & return
		
	end try
	
	return theResult
	
end convertToVBRLame

on tagLameFileFromFlac(theFile, theOutputFile)
	set theName to stripEquals(do shell script shellPath & "metaflac --show-tag=TITLE " & getQuotedForm(theFile))
	set theArtist to stripEquals(do shell script shellPath & "metaflac --show-tag=ARTIST " & getQuotedForm(theFile))
	set theDate to stripEquals(do shell script shellPath & "metaflac --show-tag=DATE " & getQuotedForm(theFile))
	set theAlbum to stripEquals(do shell script shellPath & "metaflac --show-tag=ALBUM " & getQuotedForm(theFile))
	set theComment to stripEquals(do shell script shellPath & "metaflac --show-tag=COMMENT " & getQuotedForm(theFile))
	set theGenre to stripEquals(do shell script shellPath & "metaflac --show-tag=GENRE " & getQuotedForm(theFile))
	set theTrackNumber to stripEquals(do shell script shellPath & "metaflac --show-tag=TRACKNUMBER " & getQuotedForm(theFile))
	set theDiscNumber to stripEquals(do shell script shellPath & "metaflac --show-tag=DISCNUMBER " & getQuotedForm(theFile))
	
	
	
	--set theCommand to --display dialog theCommand
	do shell script shellPath & "id3tool -t \"" & theName & "\" " & getQuotedForm(theOutputFile)
	
	do shell script shellPath & "id3tool -r \"" & theArtist & "\" " & getQuotedForm(theOutputFile)
	do shell script shellPath & "id3tool -a \"" & theAlbum & "\" " & getQuotedForm(theOutputFile)
	do shell script shellPath & "id3tool -n \"" & theComment & "\" " & getQuotedForm(theOutputFile)
	do shell script shellPath & "id3tool -c \"" & theTrackNumber & "\" " & getQuotedForm(theOutputFile)
	do shell script shellPath & "id3tool -G \"" & theGenre & "\" " & getQuotedForm(theOutputFile)
	
	
end tagLameFileFromFlac

on tagAACFileFromFlac(theFile, theOutputFile)
	set theName to stripEquals(do shell script shellPath & "metaflac --show-tag=TITLE " & getQuotedForm(theFile))
	set theArtist to stripEquals(do shell script shellPath & "metaflac --show-tag=ARTIST " & getQuotedForm(theFile))
	set theDate to stripEquals(do shell script shellPath & "metaflac --show-tag=DATE " & getQuotedForm(theFile))
	set theAlbum to stripEquals(do shell script shellPath & "metaflac --show-tag=ALBUM " & getQuotedForm(theFile))
	set theComment to stripEquals(do shell script shellPath & "metaflac --show-tag=COMMENT " & getQuotedForm(theFile))
	set theGenre to stripEquals(do shell script shellPath & "metaflac --show-tag=GENRE " & getQuotedForm(theFile))
	set theTrackNumber to stripEquals(do shell script shellPath & "metaflac --show-tag=TRACKNUMBER " & getQuotedForm(theFile))
	set theDiscNumber to stripEquals(do shell script shellPath & "metaflac --show-tag=DISCNUMBER " & getQuotedForm(theFile))
	
	set theCommand to "export AP_PADDING=\"DEFAULT_PAD=0:MAX_PAD=0\";"
	set theCommand to theCommand & space & shellPath & "AtomicParsley " & theOutputFile
	--set theCommand to theCommand & space & "--freefree 1"
	set theCommand to theCommand & space & "--overWrite"
	--set theCommand to theCommand & space & "--output " & theOutputFile
	
	--	makeMessageWindow(theCommand)
	--	display dialog "test"
	
	set theCommand to theCommand & space & "--title " & "\"" & theName & "\""
	set theCommand to theCommand & space & "--artist " & "\"" & theArtist & "\""
	set theCommand to theCommand & space & "--album " & "\"" & theAlbum & "\""
	set theCommand to theCommand & space & "--comment " & "\"" & theComment & "\""
	set theCommand to theCommand & space & "--tracknum " & "\"" & theTrackNumber & "\""
	set theCommand to theCommand & space & "--disknum " & "\"" & theDiscNumber & "\""
	set theCommand to theCommand & space & "--year " & "\"" & theDate & "\""
	set theCommand to theCommand & space & "--genre " & "\"" & theGenre & "\""
	set theCommand to theCommand & space & "--albumArtist " & "\"" & theArtist & "\""
	
	
	try
		do shell script theCommand
		
	on error errorStr
		--set outTxt to theCommand & return & errorStr
		--set theErrorFile to choose file name with prompt "Save error file as..." default name "error.txt"
		--open for access theErrorFile with write permission
		--write outTxt to theErrorFile
		--close access theErrorFile
	end try
	
	
end tagAACFileFromFlac
